/*===================================================================
 * Copyright(c) AVerMedia TECHNOLOGIES, Inc. 2017
 * All rights reserved
 * =================================================================
 * board_i2c.c
 *
 *  Created on: Apr 15, 2017
 *      Author: 
 *      Version:
 * =================================================================
 */
 
//#include <linux/kernel.h>
#include "cxt_mgr.h"
#include "i2c_model.h"
#include "board.h"
#include "board_i2c.h"
#include "gpio_model.h"
#include "cn312_sdi.h"
#include "cn312_hdmi.h"  //redeclaration of enumerato //rr
//#include "sha204.h"
#include "debug.h"
#include "board_gpio.h"
#include "sys.h"

//#define HDMI_DRVNAME I2C_MODEL_MODULE_STR(cn312_hdmi)

static const char *i2c_bus_name[BOARD_I2C_DEVICE_NUM]=
{
    [I2C_DEVICE_COM_0]="I2C_DEVICE_COM_0", 
    [I2C_DEVICE_COM_1]="I2C_DEVICE_COM_1",
};

static sdi_out_ctrl_t cn312_cfg_0={
  
    .device_index=0,
    .out_colorspace=YCbCr_422_10,     
};

static sdi_out_ctrl_t cn312_cfg_1={
    .device_index=1,
    .out_colorspace=SDI_YCbCr_422_10,    
};

static i2c_dev_info_t cn312_i2c_device0[]=
{
    {
        .name=HDMI_DRVNAME,
	    .addr=(0x4E>>1), //hdmi i2c interface
	    .context=&cn312_cfg_0, //device_index
    },
    {
        NULL,
    } 
};

static i2c_dev_info_t cn312_i2c_device1[]=
{
    {
        .name=SDI_DRVNAME,
	    .addr=(0xFE>>1), //internal SDI interface
	    .context=&cn312_cfg_1,
    },
    {
        NULL,
    } 
};

static i2c_dev_info_t *board_i2c_bus_devices[SUPPORT_BOARD_NUM][BOARD_I2C_DEVICE_NUM]=
{
  [CN312M][I2C_DEVICE_COM_0]= &cn312_i2c_device0[0],
  [CN312M][I2C_DEVICE_COM_1]= &cn312_i2c_device1[0], 
};

const char *board_get_i2c_bus_name(int no)
{
    if(no < 0 || no >= BOARD_I2C_DEVICE_NUM)
           return NULL;
    return i2c_bus_name[no];
}

int board_i2c_init(cxt_mgr_handle_t cxt_mgr,unsigned long dev_id)
{
	i2c_model_handle_t i2c_mgr=cxt_manager_get_context(cxt_mgr,I2C_CXT_ID,0);
	int err=0;
	int ret=0;

	if(i2c_mgr)
	{
        int i=0;
        i2c_dev_info_t *dev_info;
            
        #if 0
        board_set_gpio(cxt_mgr,BOARD_GPIO_RESET_CN312,GPIOIC_VALUE_HIGH);
        sys_msleep(200);
        //board_set_gpio(cxt_mgr,BOARD_GPIO_RESET_CN312,GPIOIC_VALUE_LOW);
        //sys_msleep(100);
        //board_set_gpio(cxt_mgr,BOARD_GPIO_RESET_CN312,GPIOIC_VALUE_HIGH);
        //sys_msleep(100);
        #endif
        
        //printk("============%s reset CN312\n",__func__);
               
        for(i=0;i<BOARD_I2C_DEVICE_NUM;i++) //
        {
            if(board_i2c_bus_devices[dev_id][i])
            {    
                dev_info=&board_i2c_bus_devices[dev_id][i][0];
                while((err==0) && (dev_info->name!=NULL))
                {
                    if((ret=i2c_model_bus_attach_device(i2c_mgr,i2c_bus_name[/*i*/I2C_DEVICE_COM_0],dev_info->name,dev_info->addr,dev_info->context))==0)
                    {	
                        dev_info++;
                        mesg("%s attach board_i2c...\n",__func__);
                    }
                    else
                    {
                        err=-1;
                        mesg("error in attach %s %d\n",dev_info->name,ret);//SHA204 
                        break;
                    }
                }
                if(err)
                {
                    mesg("board_i2c_init err.......................\n");
                    break;
                }
            } 
            sys_msleep(100);   
        }    
    }
    return err;
}

