/*===================================================================
 * Copyright(c) AVerMedia TECHNOLOGIES, Inc. 2017
 * All rights reserved
 * =================================================================
 * board_i2c.c
 *
 *  Created on: Apr 15, 2017
 *      Author: 
 *      Version:
 * =================================================================
 */
 
//#include <linux/kernel.h>
#include "cxt_mgr.h"
#include "i2c_model.h"
#include "board.h"
#include "board_i2c.h"
#include "gpio_model.h"
#include "adv7619.h"
#include "sha204.h"
#include "debug.h"
#include "board_gpio.h"
#include "sys.h"


static const char *i2c_bus_name[BOARD_I2C_BUS_NUM]=
{
    [I2C_BUS_COM]="I2C_BUS_COM", //reserved one I2C
   
};


static adv7619_cfg_t adv7619_cfg={
    .out_ctrl={
        .out_fmt=ADV7619_OUT_FORMAT_SDR_ITU656_24_MODE0,
        .out_colorspace=ADV7619_OUT_YUV709,  
        //.out_colorspace=ADV7619_OUT_DEFAULT,   
    },
    
};

//static void cm311h_hotplug_ctrl(handle_t cxt_mgr_handle,hotplug_pin_e pin); 
//static void cm311h_hw_reset(handle_t cxt_mgr_handle); 

//static cm311h_cfg_t cm311h_cfg=
//{
//    .slave_addr_cfg={
//      [RXLINK0] = 0x60,
//      [RXLINK1] = 0x20,
//      [TXLINK0]	= 0x70,
//      [TXLINK1] = 0x50,  
//    },
//    .hotplug_ctrl_func=NULL, 
//    .hw_reset_func=NULL,
//};


static i2c_dev_info_t cm311h_i2c_bus1_devices[]=
{
    {
        .name=ADV7619_DRVNAME,
	.addr=(0x98>>1),
	.context=&adv7619_cfg, //color space
    },
    {
        NULL,
    }
    
};

static i2c_dev_info_t *board_i2c_bus_devices[SUPPORT_BOARD_NUM][BOARD_I2C_BUS_NUM]=
{
  [CM311H][I2C_BUS_COM]= &cm311h_i2c_bus1_devices[0], //reserved one I2C
  [CL314H1][I2C_BUS_COM]= &cm311h_i2c_bus1_devices[0], //unuse and same to CM311H
};
#if 0 
//static void cm311h_hw_reset(handle_t cxt_mgr_handle)
//{
//    debug_msg("%s\n",__func__);
//    board_set_gpio(cxt_mgr_handle,BOARD_GPIO_RESET_CM311H,GPIOIC_VALUE_LOW);
//    sys_msleep(5);
//    board_set_gpio(cxt_mgr_handle,BOARD_GPIO_RESET_CM311H,GPIOIC_VALUE_HIGH);
//    sys_msleep(15);
//}

static void cm311h_hotplug_ctrl(handle_t cxt_mgr_handle,hotplug_pin_e pin)
{
    gpio_model_pin_value_t value=(pin==HOTPLUG_HIGH) ? GPIOIC_VALUE_LOW :GPIOIC_VALUE_HIGH;
    debug_msg("%s %d\n",__func__,value);
    
    board_set_gpio(cxt_mgr_handle,BOARD_GPIO_HPD_RX_CTL,value);
}
#endif

const char *board_get_i2c_bus_name(int no)
{
    if(no < 0 || no >= BOARD_I2C_BUS_NUM)
           return NULL;
    return i2c_bus_name[no];
}

int board_i2c_init(cxt_mgr_handle_t cxt_mgr,unsigned long dev_id)
{
	i2c_model_handle_t i2c_mgr=cxt_manager_get_context(cxt_mgr,I2C_CXT_ID,0);
	int err=0;
	int ret=0;

//mesg("board_i2c_init dev_id=%d\n",dev_id);
//mesg("??##?? %s cxt_mgr 0x%08x\n",__func__, cxt_mgr);

	if(i2c_mgr)
	{
            int i;
            i2c_dev_info_t *dev_info;
 
            //board_set_gpio(cxt_mgr,BOARD_GPIO_RESET_7619,GPIOIC_VALUE_LOW);
            //sys_msleep(100);
            //board_set_gpio(cxt_mgr,BOARD_GPIO_RESET_7619,GPIOIC_VALUE_HIGH);
            //sys_msleep(100);
            
             
            
            for(i=0;i<BOARD_I2C_BUS_NUM;i++)
            {
                if(board_i2c_bus_devices[dev_id][i])
                {    
                    dev_info=&board_i2c_bus_devices[dev_id][i][0];
                    while((err==0) && (dev_info->name!=NULL))
                    {
                        if((ret=i2c_model_bus_attach_device(i2c_mgr,i2c_bus_name[i],dev_info->name,dev_info->addr,dev_info->context))==0)
                        {	
                            dev_info++;
                            debug_msg("board_i2c_init ok\n");
                        }else
                        {
                            err=-1;
                            debug_msg("error in attach %s %d\n",dev_info->name,ret);//SHA204 
                            break;
                        }
                    }
                    if(err)
                    {
                        debug_msg("board_i2c_init err\n");
                        break;
                    }
                }
                
            }    
        }
        return err;
}

