/*===================================================================
 * Copyright(c) AVerMedia TECHNOLOGIES, Inc. 2017
 * All rights reserved
 * =================================================================
 * adv7604.h
 *
 *  Created on: Aug 05, 2017
 *      Author: 
 *      Version:
 * =================================================================
 */
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

#ifndef ADV7604_H
#define ADV7604_H

#ifdef __cplusplus
extern "C" {
#endif

#define ADV7604_ID adv7604
#define ADV7604_DRVNAME I2C_MODEL_MODULE_STR(adv7604)
#define ADV7604_0_DRVNAME I2C_MODEL_MODULE_STR(adv7604)

enum  Ain_e
{
	NC=0,
	AIN1=1,
	AIN2,
	AIN3,
	AIN4,
	AIN5,
	AIN6,
	AIN7,
	AIN8,
	AIN9,
	AIN10,
	AIN11,
	AIN12,
};

enum sync_pin_e
{
	SYNC1=0,
	SYNC2,
	SYNC3,
	SYNC4,
};

/* Bus rotation and reordering (IO register 0x04, [7:5]) */
enum adv7604_op_ch_sel {
	ADV7604_OP_CH_SEL_GBR = 0,
	ADV7604_OP_CH_SEL_GRB = 1,
	ADV7604_OP_CH_SEL_BGR = 2,
	ADV7604_OP_CH_SEL_RGB = 3,
	ADV7604_OP_CH_SEL_BRG = 4,
	ADV7604_OP_CH_SEL_RBG = 5,
};

/* Input Color Space (IO register 0x02, [7:4]) */
enum adv7604_inp_color_space {
	ADV7604_INP_COLOR_SPACE_LIM_RGB = 0,
	ADV7604_INP_COLOR_SPACE_FULL_RGB = 1,
	ADV7604_INP_COLOR_SPACE_LIM_YCbCr_601 = 2,
	ADV7604_INP_COLOR_SPACE_LIM_YCbCr_709 = 3,
	ADV7604_INP_COLOR_SPACE_XVYCC_601 = 4,
	ADV7604_INP_COLOR_SPACE_XVYCC_709 = 5,
	ADV7604_INP_COLOR_SPACE_FULL_YCbCr_601 = 6,
	ADV7604_INP_COLOR_SPACE_FULL_YCbCr_709 = 7,
	ADV7604_INP_COLOR_SPACE_AUTO = 0xf,
};
 
typedef enum
{
    XTAL_FREQ_28_63636MHz,
    XTAL_FREQ_27MHz,
    XTAL_FREQ_24_576MHz,        
    XTAL_FREQ_24MHz,
}adv7604_xtal_freq_e;
#if 0
typedef enum
{
    ADV7604_OUT_FORMAT_SDR_ITU656_8 = 0x00,
    ADV7604_OUT_FORMAT_SDR_ITU656_10 = 0x01,
    ADV7604_OUT_FORMAT_SDR_ITU656_12_MODE0 = 0x02,
    ADV7604_OUT_FORMAT_SDR_ITU656_12_MODE1 = 0x06,
    ADV7604_OUT_FORMAT_SDR_ITU656_12_MODE2 = 0x0a,
    ADV7604_OUT_FORMAT_DDR_422_8 = 0x20,
    ADV7604_OUT_FORMAT_DDR_422_10 = 0x21,
    ADV7604_OUT_FORMAT_DDR_422_12_MODE0 = 0x22,
    ADV7604_OUT_FORMAT_DDR_422_12_MODE1 = 0x23,
    ADV7604_OUT_FORMAT_DDR_422_12_MODE2 = 0x24,
    ADV7604_OUT_FORMAT_SDR_444_24 = 0x40,
    ADV7604_OUT_FORMAT_SDR_444_30 = 0x41,
    ADV7604_OUT_FORMAT_SDR_444_36_MODE0 = 0x42,
    ADV7604_OUT_FORMAT_SDR_444_36_MODE1 = 0x46,
    ADV7604_OUT_FORMAT_SDR_444_24_MODE3 = 0x4C,
    ADV7604_OUT_FORMAT_SDR_444_24_MODE4 = 0x50,
    ADV7604_OUT_FORMAT_SDR_444_30_MODE4 = 0x51,
    ADV7604_OUT_FORMAT_SDR_444_36_MODE4 = 0x52,
    ADV7604_OUT_FORMAT_SDR_444_2X24_INTERLEAVE_MODE0 = 0x54,            
    ADV7604_OUT_FORMAT_DDR_444_24 = 0x60,
    ADV7604_OUT_FORMAT_DDR_444_30 = 0x61,
    ADV7604_OUT_FORMAT_DDR_444_36 = 0x62,
    ADV7604_OUT_FORMAT_SDR_ITU656_16 = 0x80,
    ADV7604_OUT_FORMAT_SDR_ITU656_20 = 0x81,
    ADV7604_OUT_FORMAT_SDR_ITU656_24_MODE0 = 0x82,
    ADV7604_OUT_FORMAT_SDR_ITU656_24_MODE1 = 0x86,
    ADV7604_OUT_FORMAT_SDR_ITU656_24_MODE2 = 0x8a,
    ADV7604_OUT_FORMAT_SDR_422_20_MODE3    =0x8d,
    ADV7604_OUT_FORMAT_SDR_422_16_MODE4    =0x90,
    ADV7604_OUT_FORMAT_SDR_422_20_MODE4    =0x91,
    ADV7604_OUT_FORMAT_SDR_422_24_MODE4    =0x92,
    ADV7604_OUT_FORMAT_SDR_422_2X16_INTERLEAVE_MODE0 = 0x94,                    
    ADV7604_OUT_FORMAT_SDR_422_2X20_INTERLEAVE_MODE0 = 0x95,        
    ADV7604_OUT_FORMAT_SDR_422_2X24_INTERLEAVE_MODE0 = 0x96,        
    ADV7604_OUT_FORMAT_PAR_8_MODE0=0xc0,
    ADV7604_OUT_FORMAT_PAR_10_MODE0=0xc1,
    ADV7604_OUT_FORMAT_PAR_12_MODE0=0xc2,
    
}adv7604_out_format_e;
#endif

typedef enum {
	ADV7604_OP_FORMAT_SEL_SDR_ITU656_8 = 0x00,
	ADV7604_OP_FORMAT_SEL_SDR_ITU656_10 = 0x01,
	ADV7604_OP_FORMAT_SEL_SDR_ITU656_12_MODE0 = 0x02,
	ADV7604_OP_FORMAT_SEL_SDR_ITU656_12_MODE1 = 0x06,
	ADV7604_OP_FORMAT_SEL_SDR_ITU656_12_MODE2 = 0x0a,
	ADV7604_OP_FORMAT_SEL_DDR_422_8 = 0x20,
	ADV7604_OP_FORMAT_SEL_DDR_422_10 = 0x21,
	ADV7604_OP_FORMAT_SEL_DDR_422_12_MODE0 = 0x22,
	ADV7604_OP_FORMAT_SEL_DDR_422_12_MODE1 = 0x23,
	ADV7604_OP_FORMAT_SEL_DDR_422_12_MODE2 = 0x24,
	ADV7604_OP_FORMAT_SEL_SDR_444_24 = 0x40,
	ADV7604_OP_FORMAT_SEL_SDR_444_30 = 0x41,
	ADV7604_OP_FORMAT_SEL_SDR_444_36_MODE0 = 0x42,
	ADV7604_OP_FORMAT_SEL_DDR_444_24 = 0x60,
	ADV7604_OP_FORMAT_SEL_DDR_444_30 = 0x61,
	ADV7604_OP_FORMAT_SEL_DDR_444_36 = 0x62,
	ADV7604_OP_FORMAT_SEL_SDR_ITU656_16 = 0x80,
	ADV7604_OP_FORMAT_SEL_SDR_ITU656_20 = 0x81,
	ADV7604_OP_FORMAT_SEL_SDR_ITU656_24_MODE0 = 0x82,
	ADV7604_OP_FORMAT_SEL_SDR_ITU656_24_MODE1 = 0x86,
	ADV7604_OP_FORMAT_SEL_SDR_ITU656_24_MODE2 = 0x8a,
}adv7604_out_format_e;


enum adv7604_sync_ch_sel {
	ADV7604_SYNC_CH_DONT_CARE,
	ADV7604_SYNC_CH_SEL_AIN1_COMP,
	ADV7604_SYNC_CH_SEL_AIN2_COMP,
	ADV7604_SYNC_CH_SEL_HDMI,
	ADV7604_SYNC_CH_SEL_AIN1_GR,
	ADV7604_SYNC_CH_SEL_AIN2_GR,
};


typedef enum  {
    ADV7604_OP_CH_SEL_GBR_YUV = 0,
    ADV7604_OP_CH_SEL_GRB_YVU = 1,
    ADV7604_OP_CH_SEL_BGR_UYV = 2,
    ADV7604_OP_CH_SEL_RGB_VYU = 3,
    ADV7604_OP_CH_SEL_BRG_UVY = 4,
    ADV7604_OP_CH_SEL_RBG_VUY = 5,
}adv7604_out_ch_order_e;

typedef enum 
{
	ADV7604_OUT_DEFAULT,
    ADV7604_OUT_YUV601,
    ADV7604_OUT_YUV709,
    ADV7604_OUT_RGB_LIMITED,
    ADV7604_OUT_RGB_FULL,
}adv7604_out_colorspace_e;

typedef struct
{
    adv7604_out_format_e out_fmt;
    adv7604_out_ch_order_e out_ch_order;
    adv7604_out_colorspace_e out_colorspace;
    
    unsigned blank_data:1;  // 0: no blank data 1: blank data
    unsigned insert_av_codes:1; // 0:No AV codes 1:AV codes 
    unsigned invert_cbcr:1; // 0: follow out_format 1: swap cb,cr
    unsigned output_bus_lsb_to_msb:1; // 0: MSB to LSB 1: LSB to MSB

}adv7604_out_ctrl_t;
#if 0 
typedef struct
{
    U8_T cp_map_addr;
    U8_T hdmi_map_addr;
    U8_T repeater_map_addr;
    U8_T edid_map_addr;
    U8_T infoframe_map_addr;
    U8_T cec_map_addr;
    U8_T dpll_map_addr;
    U8_T avlink_map_addr;
    U8_T esdp_map_addr;
    U8_T dpp_map_addr;
    U8_T vfm_map_addr; //test mode
    U8_T vdp_map_addr;
    
    adv7604_xtal_freq_e xtal_freq;
    adv7604_out_ctrl_t out_ctrl;
    
}adv7604_cfg_t;
#endif

typedef void (*hw_reset_func_t)(void *);

typedef struct
{
    U8_T cp_map_addr;
    U8_T hdmi_map_addr;
    U8_T repeater_map_addr;
    U8_T edid_map_addr;
    U8_T infoframe_map_addr;
    U8_T cec_map_addr;
    U8_T dpll_map_addr;
    U8_T avlink_map_addr;
    U8_T esdp_map_addr;
    U8_T dpp_map_addr;
    U8_T vfm_map_addr; //test mode
    U8_T vdp_map_addr;
    
    adv7604_xtal_freq_e xtal_freq;
    adv7604_out_ctrl_t out_ctrl;
    
    /* connector - HDMI or DVI? */
	unsigned connector_hdmi:1;

	/* DIS_PWRDNB: 1 if the PWRDNB pin is unused and unconnected */
	unsigned disable_pwrdnb:1;

	/* DIS_CABLE_DET_RST: 1 if the 5V pins are unused and unconnected */
	unsigned disable_cable_det_rst:1;

	/* Analog input muxing mode */
	//enum adv7604_ain_sel ain_sel;
	enum Ain_e	ADC[4];
	enum sync_pin_e SOG[2];


	/* Bus rotation and reordering */
	enum adv7604_op_ch_sel op_ch_sel;

	/* Select output format */
	//enum adv7604_op_format_sel op_format_sel;
	adv7604_out_format_e op_format_sel;
	//enum adv7604_sync_ch_sel sync_ch_sel[2];
    enum adv7604_op_ch_sel sync_ch_sel[2];

	/* IO register 0x02 */
	unsigned alt_gamma:1;
	unsigned op_656_range:1;
	unsigned rgb_out:1;
	unsigned alt_data_sat:1;

	/* IO register 0x05 */
	unsigned blank_data:1;
	unsigned insert_av_codes:1;
	unsigned replicate_av_codes:1;
	unsigned invert_cbcr:1;

	/* IO register 0x30 */
	unsigned output_bus_lsb_to_msb:1;

	/* Free run */
	unsigned hdmi_free_run_mode;

	/* i2c addresses: 0 == use default */
	U8_T i2c_avlink;
	U8_T i2c_cec;
	U8_T i2c_infoframe;
	U8_T i2c_esdp;
	U8_T i2c_dpp;
	U8_T i2c_afe;
	U8_T i2c_repeater;
	U8_T i2c_edid;
	U8_T i2c_hdmi;
	U8_T i2c_test;
	U8_T i2c_cp;
	U8_T i2c_vdp;
	
	hw_reset_func_t hw_reset_func;
    
}adv7604_cfg_t;

typedef enum
{
    ADV7604_LOCK,
    ADV7604_UNLOCK,  
    ADV7604_HDCP,
      
    ADV7604_HDMI_LOCK,
    ADV7604_HDMI_UNLOCK,  
    
    ADV7604_YPBPR_LOCK,
    ADV7604_YPBPR_UNLOCK,  
       
    ADV7604_HDCP_ENABLE,
    ADV7604_HDCP_DISABLE, 
    ADV7604_HOTPLUG,
}adv7604_event_e;

typedef void (*adv7604_callback_t)(void *cxt,adv7604_event_e event);

void adv7604_add_trace(handle_t adv7604_handle,void *trace_handle);    
void adv7604_set_out_format(handle_t adv7604_handle,adv7604_out_format_e format);
void adv7604_register_callback(handle_t adv7604_handle,adv7604_callback_t callback_func,void *cxt);
void adv7604_unregister_callback(handle_t adv7604_handle);

#define CM311H_ID ce314hn
#define CM311H_DRVNAME I2C_MODEL_MODULE_STR(ce314hn)

enum    
{
    RXLINK0,
    RXLINK1,
    TXLINK0,
    TXLINK1,
    SLAVE_ADDR_COUNT,
};    
typedef enum
{
    HOTPLUG_LOW,
    HOTPLUG_HIGH,        
}hotplug_pin_e;
typedef void (*hotplug_ctrl_func_t)(void *,hotplug_pin_e);
typedef void (*hw_reset_func_t)(void *);

typedef struct
{
    U8_T slave_addr_cfg[SLAVE_ADDR_COUNT];
    hotplug_ctrl_func_t  hotplug_ctrl_func;
    hw_reset_func_t      hw_reset_func;
}ce314hn_cfg_t;

enum adv7604_mode {
	ADV7604_MODE_HDMI,
	ADV7604_MODE_COMP,
	ADV7604_MODE_GR,
	ADV7604_MODE_NONE,
	ADV7604_INPUT_NUM,
};

typedef enum
{
	ADV7604_NO_EVENT,
	ADV7604_NOTIFY_LOCKED,
	ADV7604_NOTIFY_NOSIGNAL,
	ADV7604_NOTIFY_NOSYNC,
	ADV7604_NOTIFY_SYNCED,
}adv7604_notify_e;

typedef enum
{
    CS_YUV,
    CS_RGB_FULL,
    CS_RGB_LIMIT,
}adv7604_colorspace_e;

typedef struct
{
    int brightness;
    int contrast;
    int saturation;
    int hue;
    //adv7604_colorspace_e colorspace;
}adv7604_bchs_t;

typedef enum
{
    ADV7604_BCHS_BRIGHTNESS,
    ADV7604_BCHS_CONTRAST,
    ADV7604_BCHS_HUE,        
    ADV7604_BCHS_SATURATION,
}adv7604_bchs_e;

typedef struct
{
	U32_T h_total;
    U32_T v_total;
    unsigned width;
    unsigned height;
    BOOL_T is_interlace;
    unsigned framerate;
    unsigned denominator;
    U32_T    pixel_clock;
    adv7604_colorspace_e colorspace;
    unsigned adv7604_hdcp_flag;
}adv7604_frameinfo_t;

enum adv7604_audio_sample {
	ADV7604_AUDIO_RATE_32000, //0
	ADV7604_AUDIO_RATE_44100, //1
	ADV7604_AUDIO_RATE_48000, //2
	ADV7604_AUDIO_RATE_88200,
	ADV7604_AUDIO_RATE_96000,
	ADV7604_AUDIO_RATE_176400,
	ADV7604_AUDIO_RATE_192000,
};

typedef enum
{
	ADV7604_SYNC_CH1,
	ADV7604_SYNC_CH2,
	ADV7604_SYNC_CH_COUNT,
}adv7604_sync_ch_e;

void adv7604_get_frameinfo(handle_t adv7604_handle,adv7604_frameinfo_t *frameinfo);
void adv7604_get_frameinfo_last(handle_t adv7604_handle,adv7604_frameinfo_t *frameinfo);
void adv7604_get_audioinfo(handle_t adv7604_handle,enum adv7604_audio_sample *audioinfo);

//void adv7604_set_out_bchs(handle_t adv7604_handle,adv7604_bchs_t *BCHSinfo,adv7604_bchs_e bchs);
//void adv7604_get_out_bchs(handle_t adv7604_handle,adv7604_bchs_t *BCHSinfo,adv7604_bchs_e bchs);
void adv7604_set_freerun_screen(handle_t adv7604_handle,BOOL_T is_blue_screen);

void adv7604_set_bchs(handle_t adv7604_handle,int *BCHSinfo,int *bchs_select);
//void adv7604_get_bchs(handle_t adv7604_handle,int *BCHSinfo,int *bchs_select);
void adv7604_get_brightness(handle_t adv7604_handle,int *BCHSinfo);
void adv7604_get_contrast(handle_t adv7604_handle,int *BCHSinfo);
void adv7604_get_hue(handle_t adv7604_handle,int *BCHSinfo);
void adv7604_get_saturation(handle_t adv7604_handle,int *BCHSinfo);
void adv7604_set_sync_ch(handle_t adv7604_handle,adv7604_sync_ch_e sync_ch);
void adv7604_set_input(handle_t adv7604_handle,	U32_T input);
#ifdef __cplusplus
}
#endif

#endif /* ADV7604_H */

