/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   gv7601.h
 * Author: 
 *
 * Created on Jan 25, 2018
 */

#ifndef GV7601_H
#define GV7601_H

#ifdef __cplusplus
extern "C" {
#endif


#define GV7601_ID gv7601
#define GV7601_DRVNAME I2C_MODEL_MODULE_STR(gv7601)

/////////////////////////////////////
#define PROGRESS  0
#define INTERLACE 1

#define Vneg      0
#define Hneg      0
#define Vpos      1
#define Hpos      1

//Add audio output sample bits function.
#define GV7601_AUD_24_BITS	0x00
#define GV7601_AUD_20_BITS	0x01
#define GV7601_AUD_16_BITS	0x02
#define GV7601_AUD_DEF_BITS	0x02

enum
{
    IT601_LIMIT_RANGE  = 0,
    IT601_FULL_RANGE   = 1,
    IT709_LIMIT_RANGE  = 2,
    IT709_FULL_RANGE   = 3
};

typedef enum GV7601_VidFrm_ScnMod_e
{
    GV7601_INTSCAN,
    GV7601_PRGSCAN
} GV7601_VidFrm_ScnMod_t;

typedef enum GV7601_VidFrm_Pol_e
{
    eGV7601_VidFrm_Pol_High,
    eGV7601_VidFrm_Pol_Low
} GV7601_VidFrm_Pol_t;

typedef enum eGV7601HWInitFormat_e
{
    GV7601_HW_INIT_480I = 0,
    GV7601_HW_INIT_576I ,
    GV7601_HW_INIT_720P_2398,
    GV7601_HW_INIT_720P_2400,
    GV7601_HW_INIT_720P_2500,
    GV7601_HW_INIT_720P_2997,
    GV7601_HW_INIT_720P_3000,
    GV7601_HW_INIT_720P_5000,
    GV7601_HW_INIT_720P_5994,
    GV7601_HW_INIT_720P_6000,
    GV7601_HW_INIT_1080I_5000,
    GV7601_HW_INIT_1080I_6000,
    GV7601_HW_INIT_1080PsF_2398,
    GV7601_HW_INIT_1080PsF_2400,
    GV7601_HW_INIT_1080PsF_2500,
    GV7601_HW_INIT_1080PsF_2997,
    GV7601_HW_INIT_1080PsF_3000,
    GV7601_HW_INIT_1080P_2398,
    GV7601_HW_INIT_1080P_2400,
    GV7601_HW_INIT_1080P_2500,
    GV7601_HW_INIT_1080P_2997,
    GV7601_HW_INIT_1080P_3000,
    GV7601_HW_INIT_MAX
}eGV7601HWInitFormat_t;

//[Willy_010_20150525]Add GV7601 color conversion function.
typedef enum GV7601_eResolutionType
{
	GV7601_RES_SD = 0,
	GV7601_RES_HD = 1,
}GV7601_eResolutionType_t;

enum GV7601_eOutputAudioChannel
{
    GV7601_OUTPUT_AUDIO_CHANNEL_1 = 0,
    GV7601_OUTPUT_AUDIO_CHANNEL_2,
    GV7601_OUTPUT_AUDIO_CHANNEL_3,
    GV7601_OUTPUT_AUDIO_CHANNEL_4,
    GV7601_OUTPUT_AUDIO_CHANNEL_5,
    GV7601_OUTPUT_AUDIO_CHANNEL_6,
    GV7601_OUTPUT_AUDIO_CHANNEL_7,
    GV7601_OUTPUT_AUDIO_CHANNEL_8,
    MAX_GV7601_OUTPUT_AUDIO_CHANNEL_COUNT,
};

enum GV7601_eAssignedAudioGroup
{
    GV7601_PRIMARY_AUDIO_GROUP = 0,
    GV7601_SECONDARY_AUDIO_GROUP,
    MAX_GV7601_AUDIO_GROUP,
};

// 7601 working mode, 
//  0 - 7601 working on SD video format
//  1 - 7601 working on HD video format
typedef enum //eConfigADV7601
{
    GV7601_SD_MODE,
    GV7601_HD_MODE,
}gv7601_out_format_e;


typedef struct GV7601_VidFrm_Dir_s
{
    U32_T     TOT;
    U32_T     AW;
    U32_T     FP;
    U32_T     SW;
    U32_T     Pol;
} GV7601_VidFrm_Dir_t;

typedef struct GV7601_VidFrm_Format_s
{
    GV7601_VidFrm_Dir_t     Hor;
    GV7601_VidFrm_Dir_t     Ver;
    GV7601_VidFrm_ScnMod_t  ScnMod;
    U32_T  wFrmFrq;
    eGV7601HWInitFormat_t     FormatNum;
} GV7601_VidFrm_Format_t;



//[Willy_018_20150610]Add the cea861 id condition.
typedef struct{
    U8_T   Id4x3;
    U8_T   Id16x9;
}CEA_ID;

typedef struct
{
     // IT6604 reference 
     U32_T        HActive ;       // horizontal total line
     U32_T        VActive ;       // vertical total line    
     U32_T        HTotal ;        // horizontal active line
     U32_T        VTotal ;        // vertical active line 
     //LONG        PCLK ;
     U32_T        PCLK ;
     //U8_T        xCnt ;
     U32_T        xCnt ;
     U8_T        ScanMode ;
     U8_T        VPolarity ;
     U8_T        HPolarity ;

     // self defined
     U32_T        Rate ;          // frame rate
     U32_T  QP_InCtrl ;     // [Ian_022] : add the control setting
     U32_T  QP_InRes  ;     // [Ian_022] : add the resolution setting
     U32_T  QP_InSync ;     // [Ian_022] : add the sync setting 
     
     //U8_T forced ;             // [Ian_022] : comment // [Ian_018] : 0 = disable, 
                                 //                        1 = enable forced 50/60p encode
} video_timing_t ;

typedef struct HDMI_CEA861ID
{
	CEA_ID Cea861Id;
	video_timing_t VidInfo;
} HDMI_CEA861ID;

typedef struct _GV7601_AUDIO_SOURCE_SELECTOR
{
    U8_T GroupSel;//0 or 1
    U8_T ChNum;   //0 ~ 3
} GV7601_AUDIO_SOURCE_SELECTOR;

typedef struct _GV7601_AUDIO_CROSSPOINT
{
    U8_T PrimaryGroup;
    U8_T SecodaryGroup;
    GV7601_AUDIO_SOURCE_SELECTOR OutChSrc[MAX_GV7601_OUTPUT_AUDIO_CHANNEL_COUNT];
} GV7601_AUDIO_CROSSPOINT;


/////////////////////////////////////
 
typedef enum //unuse
{
    GV7601_XTAL_FREQ_28_63636MHz,
    GV7601_XTAL_FREQ_27MHz,
    GV7601_XTAL_FREQ_24_576MHz,        
    GV7601_XTAL_FREQ_24MHz,
}gv7601_xtal_freq_e;


typedef enum  {
    GV7601_OP_CH_SEL_GBR_YUV = 0,
    GV7601_OP_CH_SEL_GRB_YVU = 1,
    GV7601_OP_CH_SEL_BGR_UYV = 2,
    GV7601_OP_CH_SEL_RGB_VYU = 3,
    GV7601_OP_CH_SEL_BRG_UVY = 4,
    GV7601_OP_CH_SEL_RBG_VUY = 5,
}gv7601_out_ch_order_e;

typedef enum 
{
    GV7601_OUT_YUV601,
    GV7601_OUT_YUV709,
    GV7601_OUT_RGB_LIMITED,
    GV7601_OUT_RGB_FULL,
}gv7601_out_colorspace_e;

typedef struct
{
    gv7601_out_format_e out_fmt;
    gv7601_out_ch_order_e out_ch_order;
    gv7601_out_colorspace_e out_colorspace;
    
    unsigned blank_data:1;  // 0: no blank data 1: blank data
    unsigned insert_av_codes:1; // 0:No AV codes 1:AV codes 
    unsigned invert_cbcr:1; // 0: follow out_format 1: swap cb,cr
    unsigned output_bus_lsb_to_msb:1; // 0: MSB to LSB 1: LSB to MSB

}gv7601_out_ctrl_t;

typedef void (*hw_reset_func_t)(void *);

typedef struct
{
    U8_T cp_map_addr;
    U8_T hdmi_map_addr;
    U8_T repeater_map_addr;
    U8_T edid_map_addr;
    U8_T infoframe_map_addr;
    U8_T cec_map_addr;
    U8_T dpll_map_addr;
    
    gv7601_xtal_freq_e xtal_freq;
    gv7601_out_ctrl_t out_ctrl;
    
    hw_reset_func_t hw_reset_func;
    
}gv7601_cfg_t;

typedef enum
{
    GV7601_LOCK,
    GV7601_UNLOCK,        
    //GV7601_HDCP,        
}gv7601_event_e;

typedef void (*gv7601_callback_t)(void *cxt,gv7601_event_e event);

typedef enum
{
    GV7601_CS_YUV,
    GV7601_CS_RGB_FULL,
    GV7601_CS_RGB_LIMIT,
}gv7601_colorspace_e;

typedef struct
{
    int width;
    int height;
    BOOL_T is_interlace;
    int framerate;
    int denominator;
    U32_T    pixel_clock;
    //gv7601_colorspace_e colorspace;
    gv7601_out_colorspace_e colorspace;
	int hbackporch;
	int vbackporch;
	int htotal;
	int vtotal;
	
}gv7601_frameinfo_t;


void gv7601_get_frameinfo(handle_t gv7601_handle,gv7601_frameinfo_t *frameinfo);

void gv7601_add_trace(handle_t gv7601_handle,void *trace_handle);    
void gv7601_set_out_format(handle_t gv7601_handle,gv7601_out_format_e format);
void gv7601_register_callback(handle_t gv7601_handle, gv7601_callback_t callback_func, void *cxt);
void gv7601_unregister_callback(handle_t gv7601_handle);

///////////////////////////


#ifdef __cplusplus
}
#endif

#endif /* GV7601_H */

