#ifndef PCA9539A_H_
#define PCA9539A_H_

#ifdef __cplusplus
extern "C" {
#endif

#define PCA9539A_ID pca9539a
#define PCA9539A_DRVNAME I2C_MODEL_MODULE_STR(pca9539a)

typedef void (*hw_reset_func_t)(void *);

typedef struct {
	hw_reset_func_t hw_reset_func;
} pca9539a_cfg_t;


#define PCA9539A_DEFAULT_I2C_ADDR    0xE8

#define	PCA9539A_INPUT_P0		0x00
#define	PCA9539A_INPUT_P1		0x01
#define	PCA9539A_OUTPUT_P0		0x02
#define	PCA9539A_OUTPUT_P1		0x03
#define	PCA9539A_POL_INV_P0		0x04
#define	PCA9539A_POL_INV_P1		0x05
#define	PCA9539A_CFG_P0			0x06
#define	PCA9539A_CFG_P1			0x07

typedef enum
{
	PCA9539A_P0 = 0,
	PCA9539A_P1 = 1,
} pca9539a_port;

typedef enum
{
	PCA9539A_DIR_OUTPUT = 0,
	PCA9539A_DIR_INPUT = 1,
} pca9539a_gpio_dir;

typedef enum
{
	PCA9539A_VALUE_LOW = 0,
	PCA9539A_VALUE_HIGH = 1,
	PCA9539A_VALUE_HIGH_IMPEDANCE = 2,
} pca9539a_gpio_value;

//int pca9539a_set_gpio(handle_t pca9539a_handle,pca9539a_port port, U8_T number, pca9539a_gpio_dir direction, pca9539a_gpio_value value);

//int pca9539a_get_gpio(handle_t pca9539a_handle,pca9539a_port port, U8_T number, pca9539a_gpio_value value);
	
#ifdef __cplusplus
}
#endif

#endif /* PCA9539A_H_ */

