/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   cn312_hdmi.h
 * Author: 
 *
 * Created on Jan 25, 2018
 */

#ifndef CN312_hdmi_H
#define CN312_hdmi_H

#ifdef __cplusplus
extern "C" {
#endif


/***************************** Include Files *********************************/
#include "xparameters.h"

#include "xil_io.h"

#if defined (XPAR_XUARTLITE_NUM_INSTANCES)
#include "xuartlite_l.h"
#else
#include "xuartps.h"
#endif

#include "xil_types.h"
#include "xil_exception.h"

#include "xvidc.h"
#include "xv_hdmic.h"
#include "xv_hdmic_vsif.h"

#ifdef XPAR_XV_HDMIRXSS_NUM_INSTANCES
#include "xv_hdmirxss.h"
#endif

#include "xvphy.h"

#if defined (ARMR5) || (__aarch64__) || (__arm__)
#include "xscugic.h"
#else
#include "xintc.h"
#endif

/* AUXFIFOSIZE: Must be set to 3 or higher*/
#define AUXFIFOSIZE 10

/************************** Constant Definitions *****************************/
#define I2C_MUX_ADDR    0x74  /**< I2C Mux Address */
#if (defined XPS_BOARD_ZCU104)
#define I2C_CLK_ADDR    0x6C  /**< I2C Clk Address IDT_8T49N241*/
#else
#define I2C_CLK_ADDR    0x68  /**< I2C Clk Address */
#endif

#define ANSI_COLOR_RED     "\x1b[31m"
#define ANSI_COLOR_YELLOW  "\x1b[33m"
#define ANSI_COLOR_RESET   "\x1b[0m"


/************************** Constant Definitions *****************************/

/******************************** OPTIONS ************************************/
/* Enabling this will disable Pass-through mode and TX and RX will operate
 * separately
 */
#define LOOPBACK_MODE_EN 0

/* Enabling this will enable a debug UART menu */
#define HDMI_DEBUG_TOOLS 0

/* Enabling this will register a custom resolution to the video timing table
 */
#define CUSTOM_RESOLUTION_ENABLE 1

#if defined (XPAR_XHDCP_NUM_INSTANCES) || \
		defined (XPAR_XHDCP22_RX_NUM_INSTANCES) || \
	defined (XPAR_XHDCP22_TX_NUM_INSTANCES)
/* If HDCP 1.4 or HDCP 2.2 is in the system then use the HDCP abstraction layer */
#define USE_HDCP
#endif

/* Enabling this will enable HDCP Debug menu */
#define HDCP_DEBUG_MENU_EN 0

/* Enabling this will enable Video Masking menu */
#define VIDEO_MASKING_MENU_EN 0

/************************** Variable Definitions *****************************/


/* TX busy flag. This flag is set while the TX is initialized*/
extern u8 TxBusy;
extern u8 IsPassThrough;


#define hdmi_ID cn312_hdmi
#define HDMI_DRVNAME I2C_MODEL_MODULE_STR(cn312_hdmi)
#define ACTIVE_PATH_NUM 2
#define hdmi_STREAM_A 0
#define hdmi_STREAM_B 1

int hdmi_wr_reg_xil(int reg, u8* pBuf);
int hdmi_rd_reg_xil(int reg, u8* pBuf);

enum eDevicehdmi
{
	DEVICE_hdmi_0			//1'st Xilinxhdmi
	//DEVICE_hdmi_1,
};

enum eStandardhdmi
{
	hdmi_SD = 0x01,
	hdmi_HD,
	hdmi_3GA,
	hdmi_3GA_2K,
	hdmi_3GA_UNKNOWN,
	hdmi_3GB,
	hdmi_3GB_2STR,
	hdmi_3GB_2K,
	hdmi_3GB_UNKNOWN,
	hdmi_UNKNOWN = 0xf
};

#if 1
enum eColorModehdmi
{
    VIDEO_YUV_FMT,
    VIDEO_RGB_FULL_FMT,
    VIDEO_RGB_LIMIT_FMT,
};

enum ePixelModehdmi
{
	SINGLE_PIXEL_MODE,
	DUAL_PIXEL_MODE,
};

enum eVideoTypehdmi
{
    VIDEO_RGB_MODE,
    VIDEO_422_MODE,
    VIDEO_444_MODE,
    VIDEO_420_MODE,
};
#endif

enum eColorFormathdmi
{
	YCbCr_422_10 = 0,
	YCbCr_444_10,
	RGB_444_10,
	YCbCrA_4444_10,
	RGBA_4444_10,
	YCbCr_422_12,
	YCbCr_444_12,
	RGB_444_12,
	XYZ_444_12
};

enum eFrameRatehdmi
{
	hdmi_FPS_NONE = 0,
	hdmi_FPS_2398 = 2,
	hdmi_FPS_2400,
	hdmi_FPS_4795,
	hdmi_FPS_2500,
	hdmi_FPS_2997,
	hdmi_FPS_3000,
	hdmi_FPS_4800,
	hdmi_FPS_5000,
	hdmi_FPS_5994,
	hdmi_FPS_6000
};

enum eRGBtoYUVhdmi
{
	y_g_coef = 0,
	y_b_coef,
	y_r_coef,
	y_offset,
	cb_g_coef,
	cb_b_coef,
	cb_r_coef,
	cb_offset,
	cr_g_coef,
	cr_b_coef,
	cr_r_coef,
	cr_offset,

	y_g_coef_s,
	y_b_coef_s,
	y_r_coef_s,
	y_offset_s,
	cb_g_coef_s,
	cb_b_coef_s,
	cb_r_coef_s,
	cb_offset_s,
	cr_g_coef_s,
	cr_b_coef_s,
	cr_r_coef_s,
	cr_offset_s
};

enum eYUVtoRGBhdmi
{
	g_y_coef = 0,
	g_cb_coef,
	g_cr_coef,
	b_y_coef,
	b_cb_coef,
	b_cr_coef,
	r_y_coef,
	r_cb_coef,
	r_cr_coef,

	g_y_coef_s,
	g_cb_coef_s,
	g_cr_coef_s,
	b_y_coef_s,
	b_cb_coef_s,
	b_cr_coef_s,
	r_y_coef_s,
	r_cb_coef_s,
	r_cr_coef_s,

	y2_offset,
	cb2_offset,
	cr2_offset,
	y2_offset_s,
	cb2_offset_s,
	cr2_offset_s
};

static const int RGBtoYUV_TABLE[24][4] =
{
	//				RGBF_to_BT709		RGBL_to_BT709		RGBF_to_BT601		RGBL_to_BT601
	/*y_g_coef*/	{ 10063,			11718,				8259,				9617},
	/*y_b_coef*/	{ 1016,				1183,				1604,				1868},
	/*y_r_coef*/	{ 2992,				3483,				4207,				4899},
	/*y_offset*/	{ 256,				0,					256,				0},
	/*cb_g_coef*/	{ 5548,				6459,				4768,				5551},
	/*cb_b_coef*/	{ 7196,				8379,				7196,				8379},
	/*cb_r_coef*/	{ 1648,				1920,				2428,				2828},
	/*cb_offset*/	{ 2048,				2048,				2048,				2048},
	/*cr_g_coef*/	{ 6536,				7610,				6024,				7016},
	/*cr_b_coef*/	{ 660,				768,				1171,				1363},
	/*cr_r_coef*/	{ 7196,				8379,				7196,				8379},
	/*cr_offset*/	{ 2048,				2048,				2048,				2048},

	/*y_g_coef_s*/	{ 0,				0,					0,					0},
	/*y_b_coef_s*/	{ 0,				0,					0,					0},
	/*y_r_coef_s*/	{ 0,				0,					0,					0},
	/*y_offset_s*/	{ 0,				0,					0,					0},
	/*cb_g_coef_s*/	{ 1,				1,					1,					1},
	/*cb_b_coef_s*/	{ 0,				0,					0,					0},
	/*cb_r_coef_s*/	{ 1,				1,					1,					1},
	/*cb_offset_s*/	{ 0,				0,					0,					0},
	/*cr_g_coef_s*/	{ 1,				1,					1,					1},
	/*cr_b_coef_s*/	{ 1,				1,					1,					1},
	/*cr_r_coef_s*/	{ 0,				0,					0,					0},
	/*cr_offset_s*/	{ 0,				0,					0,					0},
};

static const int YUVtoRGB_TABLE[30][6] =
{
	//	BT709_to_RGBF		BT709_to_RGBL		BT601_to_RGBF		BT601_to_RGBL		BT601_to_BT709		BT709_to_BT601
/*g_y_coef*/	{ 19078,		16384,			19078,			16384,			16384,			16384,},
/*g_cb_coef*/	{ 3495,			3000,			6418,			5512,			1892,			1629,},
/*g_cr_coef*/	{ 8731,			7499,			13320,			11439,			3406,			3141,},
/*b_y_coef*/	{ 19078,		16384,			19078,			16384,			0,			0,},
/*b_cb_coef*/	{ 34611,		29724,			33051,			28385,			16689,			16219,},
/*b_cr_coef*/	{ 0,			0,			0,			0,			1878,			1812,},
/*r_y_coef*/	{ 19078,		16384,			19078,			16384,			0,			0,},
/*r_cb_coef*/	{ 0,			0,			0,			0,			1229,			1189,},
/*r_cr_coef*/	{ 29373,		25226,			26149,			22458,			16799,			16112,},

/*g_y_coef_s*/	{ 0,			0,			0,			0,			0,			0,},
/*g_cb_coef_s*/	{ 1,			1,			1,			1,			1,			0,},
/*g_cr_coef_s*/	{ 1,			1,			1,			1,			1,			0,},
/*b_y_coef_s*/	{ 0,			0,			0,			0,			0,			0,},
/*b_cb_coef_s*/	{ 0,			0,			0,			0,			0,			0,},
/*b_cr_coef_s*/	{ 0,			0,			0,			0,			0,			1,},
/*r_y_coef_s*/	{ 0,			0,			0,			0,			0,			0,},
/*r_cb_coef_s*/	{ 0,			0,			0,			0,			0,			1,},
/*r_cr_coef_s*/	{ 0,			0,			0,			0,			0,			0,},

/*y2_offset*/	{ 1230,			1312,			2169,			2118,			662,			596,},
/*cb2_offset*/	{ 4624,			3715,			4429,			3548,			272,			247,},
/*cr2_offset*/	{ 3969,			3153,			3566,			2807,			205,			182,},
/*y2_offset_s*/	{ 0,			0,			0,			0,			0,			1,},
/*cb2_offset_s*/{ 1,			1,			1,			1,			1,			0,},
/*cr2_offset_s*/{ 1,			1,			1,			1,			1,			0,},
};

/////////////////////////////////////
#define PROGRESS  0
#define INTERLACE 1

#define Vneg      0
#define Hneg      0
#define Vpos      1
#define Hpos      1

//Add audio output sample bits function.
#define hdmi_AUD_24_BITS	0x00
#define hdmi_AUD_20_BITS	0x01
#define hdmi_AUD_16_BITS	0x02
#define hdmi_AUD_DEF_BITS	0x02

enum
{
    IT601_LIMIT_RANGE  = 0,
    IT601_FULL_RANGE   = 1,
    IT709_LIMIT_RANGE  = 2,
    IT709_FULL_RANGE   = 3
};

typedef enum hdmi_VidFrm_ScnMod_e
{
    hdmi_INTSCAN,
    hdmi_PRGSCAN
} hdmi_VidFrm_ScnMod_t;

typedef enum hdmi_VidFrm_Pol_e
{
    ehdmi_VidFrm_Pol_High,
    ehdmi_VidFrm_Pol_Low
} hdmi_VidFrm_Pol_t;

typedef enum ehdmiHWInitFormat_e
{
    hdmi_HW_INIT_480I = 0,
    hdmi_HW_INIT_576I ,
    hdmi_HW_INIT_720P_2398,
    hdmi_HW_INIT_720P_2400,
    hdmi_HW_INIT_720P_2500,
    hdmi_HW_INIT_720P_2997,
    hdmi_HW_INIT_720P_3000,
    hdmi_HW_INIT_720P_5000,
    hdmi_HW_INIT_720P_5994,
    hdmi_HW_INIT_720P_6000,
    hdmi_HW_INIT_1080I_5000,
    hdmi_HW_INIT_1080I_6000,
    hdmi_HW_INIT_1080PsF_2398,
    hdmi_HW_INIT_1080PsF_2400,
    hdmi_HW_INIT_1080PsF_2500,
    hdmi_HW_INIT_1080PsF_2997,
    hdmi_HW_INIT_1080PsF_3000,
    hdmi_HW_INIT_1080P_2398,
    hdmi_HW_INIT_1080P_2400,
    hdmi_HW_INIT_1080P_2500,
    hdmi_HW_INIT_1080P_2997,
    hdmi_HW_INIT_1080P_3000,
    hdmi_HW_INIT_MAX
}ehdmiHWInitFormat_t;

//[Willy_010_20150525]Add hdmi color conversion function.
typedef enum hdmi_eResolutionType
{
	hdmi_RES_SD = 0,
	hdmi_RES_HD = 1,
}hdmi_eResolutionType_t;

enum hdmi_eOutputAudioChannel
{
    hdmi_OUTPUT_AUDIO_CHANNEL_1 = 0,
    hdmi_OUTPUT_AUDIO_CHANNEL_2,
    hdmi_OUTPUT_AUDIO_CHANNEL_3,
    hdmi_OUTPUT_AUDIO_CHANNEL_4,
    hdmi_OUTPUT_AUDIO_CHANNEL_5,
    hdmi_OUTPUT_AUDIO_CHANNEL_6,
    hdmi_OUTPUT_AUDIO_CHANNEL_7,
    hdmi_OUTPUT_AUDIO_CHANNEL_8,
    MAX_hdmi_OUTPUT_AUDIO_CHANNEL_COUNT,
};

enum hdmi_eAssignedAudioGroup
{
    hdmi_PRIMARY_AUDIO_GROUP = 0,
    hdmi_SECONDARY_AUDIO_GROUP,
    MAX_hdmi_AUDIO_GROUP,
};

// 7601 working mode, 
//  0 - 7601 working on SD video format
//  1 - 7601 working on HD video format
typedef enum //eConfigADV7601
{
    hdmi_SD_MODE,
    hdmi_HD_MODE,
}hdmi_out_format_e;


typedef struct hdmi_VidFrm_Dir_s
{
    U32_T     TOT;
    U32_T     AW;
    U32_T     FP;
    U32_T     SW;
    U32_T     Pol;
} hdmi_VidFrm_Dir_t;

typedef struct hdmi_VidFrm_Format_s
{
    hdmi_VidFrm_Dir_t     Hor;
    hdmi_VidFrm_Dir_t     Ver;
    hdmi_VidFrm_ScnMod_t  ScnMod;
    U32_T  wFrmFrq;
    ehdmiHWInitFormat_t     FormatNum;
} hdmi_VidFrm_Format_t;

//[Willy_018_20150610]Add the cea861 id condition.
typedef struct{
    U8_T   Id4x3;
    U8_T   Id16x9;
}CEA_ID;

typedef struct
{
     // IT6604 reference 
     U32_T        HActive ;       // horizontal total line
     U32_T        VActive ;       // vertical total line    
     U32_T        HTotal ;        // horizontal active line
     U32_T        VTotal ;        // vertical active line 
     //LONG        PCLK ;
     U32_T        PCLK ;
     //U8_T        xCnt ;
     U32_T        xCnt ;
     U8_T        ScanMode ;
     U8_T        VPolarity ;
     U8_T        HPolarity ;

     // self defined
     U32_T        Rate ;          // frame rate
     U32_T  QP_InCtrl ;     // [Ian_022] : add the control setting
     U32_T  QP_InRes  ;     // [Ian_022] : add the resolution setting
     U32_T  QP_InSync ;     // [Ian_022] : add the sync setting 
     
     //U8_T forced ;             // [Ian_022] : comment // [Ian_018] : 0 = disable, 
                                 //                        1 = enable forced 50/60p encode
} video_timing_t ;

typedef struct HDMI_CEA861ID
{
	CEA_ID Cea861Id;
	video_timing_t VidInfo;
} HDMI_CEA861ID;

typedef struct _hdmi_AUDIO_SOURCE_SELECTOR
{
    U8_T GroupSel;//0 or 1
    U8_T ChNum;   //0 ~ 3
} hdmi_AUDIO_SOURCE_SELECTOR;

typedef struct _hdmi_AUDIO_CROSSPOINT
{
    U8_T PrimaryGroup;
    U8_T SecodaryGroup;
    hdmi_AUDIO_SOURCE_SELECTOR OutChSrc[MAX_hdmi_OUTPUT_AUDIO_CHANNEL_COUNT];
} hdmi_AUDIO_CROSSPOINT;

/////////////////////////////////////

typedef enum  {
    hdmi_OP_CH_SEL_GBR_YUV = 0,
    hdmi_OP_CH_SEL_GRB_YVU = 1,
    hdmi_OP_CH_SEL_BGR_UYV = 2,
    hdmi_OP_CH_SEL_RGB_VYU = 3,
    hdmi_OP_CH_SEL_BRG_UVY = 4,
    hdmi_OP_CH_SEL_RBG_VUY = 5,
}hdmi_out_ch_order_e;

typedef enum 
{
    hdmi_OUT_YUV601,
    hdmi_OUT_YUV709,
    hdmi_OUT_RGB_LIMITED,
    hdmi_OUT_RGB_FULL,
}hdmi_out_colorspace_e;

typedef struct
{
    int device_index;
    hdmi_out_colorspace_e out_colorspace;
}hdmi_out_ctrl_t;

typedef enum
{
    HDMI_LOCK,
    HDMI_UNLOCK, 
    HDMI_AUDIO_CHG,       
    //hdmi_HDCP,        
}hdmi_event_e;

typedef void (*hdmi_callback_t)(void *cxt,hdmi_event_e event);

typedef enum
{
    hdmi_CS_YUV,
    hdmi_CS_RGB_FULL,
    hdmi_CS_RGB_LIMIT,
}hdmi_colorspace_e;

typedef struct
{
    int width;
    int height;
    BOOL_T is_interlace;
    int framerate;
    int denominator;
    U32_T pixel_clock;
    hdmi_out_colorspace_e colorspace;
    int hbackporch;
    int vbackporch;
    int htotal;
    int vtotal;
	
}hdmi_frameinfo_t;

enum hdmi_audio_sample {
	hdmi_AUDIO_RATE_32000, //0
	hdmi_AUDIO_RATE_44100, //1
	hdmi_AUDIO_RATE_48000, //2
	hdmi_AUDIO_RATE_88200,
	hdmi_AUDIO_RATE_96000,
	hdmi_AUDIO_RATE_176400,
	hdmi_AUDIO_RATE_192000,
};

typedef struct
{
	U8_T m_WorkingMode;
	U8_T m_ColorSpaceMode;
	U8_T m_SamplingMode;
	U8_T m_PixelMode;
	U32_T m_PacketRepetition;
	U32_T m_PacketVideoLock;
	U32_T m_PacketWidth;
	U32_T m_PacketHeight;
	U32_T m_PacketInterlace;
	U32_T m_PacketFrameRate;
	U32_T m_RxFrameRate;

	U8_T m_Old_WorkingMode;
	U8_T m_Old_ColorSpaceMode;
	U8_T m_Old_SamplingMode;
	U8_T m_Old_PixelMode;
	U32_T m_Old_PacketRepetition;
	U32_T m_Old_PacketVideoLock;
	U32_T m_Old_PacketWidth;
	U32_T m_Old_PacketHeight;
	U32_T m_Old_PacketInterlace;
	U32_T m_Old_PacketFrameRate;
	U32_T m_Old_RxFrameRate;
	
	U8_T m_WorkingMode_in;
	U8_T m_WorkingMode_out;
	U32_T m_CSFourCC_out;
	U8_T m_PixelFmt_out;
	U8_T m_ColorSpaceMode_in; // VIDEO_YUV_FMT // VIDEO_RGB_FULL_FMT // VIDEO_RGB_LIMIT_FMT
}hdmi_packetinfo_t;

typedef enum AVER_COLORIMETRY {
    AVER_COLORIMETRY_RGB_LIMITED,
    AVER_COLORIMETRY_YUV_601,
    AVER_COLORIMETRY_YUV_709,
    AVER_COLORIMETRY_xvYCC_601,
    AVER_COLORIMETRY_xvYCC_709,
    AVER_COLORIMETRY_sYCC_601,
    AVER_COLORIMETRY_Adobe_YCC_601,     //opYCC601
    AVER_COLORIMETRY_Adobe_RGB,         //opRGB
    AVER_COLORIMETRY_BT2020_cYCC,       //BT2020 YCC Constant Luminance
    AVER_COLORIMETRY_BT2020_YCC,        //BT2020 YCC non-Constant Luminance
    AVER_COLORIMETRY_BT2020_RGB,
    AVER_COLORIMETRY_DCI_P3_D65,
    AVER_COLORIMETRY_DCI_P3_Theater,

    //Full Range Colorimetry
    AVER_COLORIMETRY_FULL_RANGE = 1000,
    AVER_COLORIMETRY_RGB_FULL               = AVER_COLORIMETRY_FULL_RANGE + AVER_COLORIMETRY_RGB_LIMITED,
    AVER_COLORIMETRY_YUV_601_FULL           = AVER_COLORIMETRY_FULL_RANGE + AVER_COLORIMETRY_YUV_601,
    AVER_COLORIMETRY_YUV_709_FULL           = AVER_COLORIMETRY_FULL_RANGE + AVER_COLORIMETRY_YUV_709,
    AVER_COLORIMETRY_xvYCC_601_FULL         = AVER_COLORIMETRY_FULL_RANGE + AVER_COLORIMETRY_xvYCC_601,
    AVER_COLORIMETRY_xvYCC_709_FULL         = AVER_COLORIMETRY_FULL_RANGE + AVER_COLORIMETRY_xvYCC_709,
    AVER_COLORIMETRY_sYCC_601_FULL          = AVER_COLORIMETRY_FULL_RANGE + AVER_COLORIMETRY_sYCC_601,
    AVER_COLORIMETRY_Adobe_YCC_601_FULL     = AVER_COLORIMETRY_FULL_RANGE + AVER_COLORIMETRY_Adobe_YCC_601,
    AVER_COLORIMETRY_Adobe_RGB_FULL         = AVER_COLORIMETRY_FULL_RANGE + AVER_COLORIMETRY_Adobe_RGB,
    AVER_COLORIMETRY_BT2020_cYCC_FULL       = AVER_COLORIMETRY_FULL_RANGE + AVER_COLORIMETRY_BT2020_cYCC,
    AVER_COLORIMETRY_BT2020_YCC_FULL        = AVER_COLORIMETRY_FULL_RANGE + AVER_COLORIMETRY_BT2020_YCC,
    AVER_COLORIMETRY_BT2020_RGB_FULL        = AVER_COLORIMETRY_FULL_RANGE + AVER_COLORIMETRY_BT2020_RGB,
    AVER_COLORIMETRY_DCI_P3_D65_FULL        = AVER_COLORIMETRY_FULL_RANGE + AVER_COLORIMETRY_DCI_P3_D65,
    AVER_COLORIMETRY_DCI_P3_Theater_FULL    = AVER_COLORIMETRY_FULL_RANGE + AVER_COLORIMETRY_DCI_P3_Theater,

    AVER_COLORIMETRY_UNKNOWN = 0xFFFFFFFF,
} eAVER_COLORIMETRY;

enum hdmi_colorspace {
    HDMI_COLORSPACE_RGB,
    HDMI_COLORSPACE_YUV422,
    HDMI_COLORSPACE_YUV444,
    HDMI_COLORSPACE_YUV420,
    HDMI_COLORSPACE_RESERVED4,
    HDMI_COLORSPACE_RESERVED5,
    HDMI_COLORSPACE_RESERVED6,
    HDMI_COLORSPACE_IDO_DEFINED,
};

enum hdmi_colorimetry {
    HDMI_COLORIMETRY_NONE,
    HDMI_COLORIMETRY_ITU_601,
    HDMI_COLORIMETRY_ITU_709,
    HDMI_COLORIMETRY_EXTENDED,
};

enum hdmi_extended_colorimetry {
    HDMI_EXTENDED_COLORIMETRY_XV_YCC_601,
    HDMI_EXTENDED_COLORIMETRY_XV_YCC_709,
    HDMI_EXTENDED_COLORIMETRY_S_YCC_601,
    HDMI_EXTENDED_COLORIMETRY_ADOBE_YCC_601,
    HDMI_EXTENDED_COLORIMETRY_ADOBE_RGB,

    /* The following EC values are only defined in CEA-861-F. */
    HDMI_EXTENDED_COLORIMETRY_BT2020_CONST_LUM,
    HDMI_EXTENDED_COLORIMETRY_BT2020,
    HDMI_EXTENDED_COLORIMETRY_RESERVED,
};

enum hdmi_quantization_range {
    HDMI_QUANTIZATION_RANGE_DEFAULT,
    HDMI_QUANTIZATION_RANGE_LIMITED,
    HDMI_QUANTIZATION_RANGE_FULL,
    HDMI_QUANTIZATION_RANGE_RESERVED,
};

enum hdmi_ycc_quantization_range {
    HDMI_YCC_QUANTIZATION_RANGE_LIMITED,
    HDMI_YCC_QUANTIZATION_RANGE_FULL,
};

enum hdmi_additional_colorimetry_extension {
    HDMI_ACE_DCI_P3_RGB_D65,
    HDMI_ACE_DCI_P3_RGB_THEATER,
};

void hdmi_get_frameinfo(handle_t hdmi_handle,hdmi_frameinfo_t *frameinfo);
//void hdmi_yuv2rgb_coeff(handle_t hdmi_handle,int ch, int coeff_mode);
//void hdmi_rgb2yuv_coeff(handle_t hdmi_handle,int ch, int coeff_mode);
void hdmi_get_packetinfo(handle_t hdmi_handle,hdmi_packetinfo_t *hdmi_packetinfo);
int hdmi_get_audio_sample(handle_t hdmi_handle);
void hdmi_set_color_space(handle_t hdmi_handle,hdmi_packetinfo_t *hdmi_packetinfo);

void hdmi_add_trace(handle_t hdmi_handle,void *trace_handle);    
void hdmi_set_out_format(handle_t hdmi_handle,hdmi_out_format_e format);
void hdmi_set_audio_out_enable(handle_t hdmi_handle,BOOL_T Enable,int ch);
void hdmi_register_callback(handle_t hdmi_handle, hdmi_callback_t callback_func, void *cxt);
void hdmi_unregister_callback(handle_t hdmi_handle);
void hdmi_set_stream(handle_t hdmi_handle, U32_T input);

void hdmi_power_off(handle_t hdmi_handle);
void hdmi_power_on(handle_t hdmi_handle);

///////////////////////////


#ifdef __cplusplus
}
#endif

#endif /* CN312_hdmi_H */

