#ifndef XPARAMETERS_H   /* prevent circular inclusions */
#define XPARAMETERS_H   /* by using protection macros */

//#define XILINX_MCU_EXIST //AVerMedia_Jeff_20190313

/* Definitions for bus frequencies */
#define XPAR_CPU_M_AXI_DP_FREQ_HZ 100000000
/******************************************************************/

/* Canonical definitions for bus frequencies */
/******************************************************************/

#define XPAR_CPU_CORE_CLOCK_FREQ_HZ 100000000
#define XPAR_MICROBLAZE_CORE_CLOCK_FREQ_HZ 100000000

/******************************************************************/


/* Definitions for peripheral MB_SS_0_MBLAZE */
#define XPAR_MB_SS_0_MBLAZE_ADDR_SIZE 32
#define XPAR_MB_SS_0_MBLAZE_ADDR_TAG_BITS 17
#define XPAR_MB_SS_0_MBLAZE_ALLOW_DCACHE_WR 1
#define XPAR_MB_SS_0_MBLAZE_ALLOW_ICACHE_WR 1
#define XPAR_MB_SS_0_MBLAZE_AREA_OPTIMIZED 0
#define XPAR_MB_SS_0_MBLAZE_ASYNC_INTERRUPT 1
#define XPAR_MB_SS_0_MBLAZE_ASYNC_WAKEUP 3
#define XPAR_MB_SS_0_MBLAZE_AVOID_PRIMITIVES 0
#define XPAR_MB_SS_0_MBLAZE_BASE_VECTORS 0x0000000000000000
#define XPAR_MB_SS_0_MBLAZE_BRANCH_TARGET_CACHE_SIZE 0
#define XPAR_MB_SS_0_MBLAZE_CACHE_BYTE_SIZE 8192
#define XPAR_MB_SS_0_MBLAZE_DADDR_SIZE 32
#define XPAR_MB_SS_0_MBLAZE_DATA_SIZE 32
#define XPAR_MB_SS_0_MBLAZE_DCACHE_ADDR_TAG 17
#define XPAR_MB_SS_0_MBLAZE_DCACHE_ALWAYS_USED 0
#define XPAR_MB_SS_0_MBLAZE_DCACHE_BASEADDR 0x00000000
#define XPAR_MB_SS_0_MBLAZE_DCACHE_BYTE_SIZE 8192
#define XPAR_MB_SS_0_MBLAZE_DCACHE_DATA_WIDTH 0
#define XPAR_MB_SS_0_MBLAZE_DCACHE_FORCE_TAG_LUTRAM 0
#define XPAR_MB_SS_0_MBLAZE_DCACHE_HIGHADDR 0x3FFFFFFF
#define XPAR_MB_SS_0_MBLAZE_DCACHE_LINE_LEN 4
#define XPAR_MB_SS_0_MBLAZE_DCACHE_USE_WRITEBACK 0
#define XPAR_MB_SS_0_MBLAZE_DCACHE_VICTIMS 0
#define XPAR_MB_SS_0_MBLAZE_DC_AXI_MON 0
#define XPAR_MB_SS_0_MBLAZE_DEBUG_COUNTER_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_DEBUG_ENABLED 1
#define XPAR_MB_SS_0_MBLAZE_DEBUG_EVENT_COUNTERS 5
#define XPAR_MB_SS_0_MBLAZE_DEBUG_EXTERNAL_TRACE 0
#define XPAR_MB_SS_0_MBLAZE_DEBUG_INTERFACE 0
#define XPAR_MB_SS_0_MBLAZE_DEBUG_LATENCY_COUNTERS 1
#define XPAR_MB_SS_0_MBLAZE_DEBUG_PROFILE_SIZE 0
#define XPAR_MB_SS_0_MBLAZE_DEBUG_TRACE_ASYNC_RESET 0
#define XPAR_MB_SS_0_MBLAZE_DEBUG_TRACE_SIZE 8192
#define XPAR_MB_SS_0_MBLAZE_DIV_ZERO_EXCEPTION 0
#define XPAR_MB_SS_0_MBLAZE_DP_AXI_MON 0
#define XPAR_MB_SS_0_MBLAZE_DYNAMIC_BUS_SIZING 0
#define XPAR_MB_SS_0_MBLAZE_D_AXI 1
#define XPAR_MB_SS_0_MBLAZE_D_LMB 1
#define XPAR_MB_SS_0_MBLAZE_D_LMB_MON 0
#define XPAR_MB_SS_0_MBLAZE_ECC_USE_CE_EXCEPTION 0
#define XPAR_MB_SS_0_MBLAZE_EDGE_IS_POSITIVE 1
#define XPAR_MB_SS_0_MBLAZE_ENABLE_DISCRETE_PORTS 0
#define XPAR_MB_SS_0_MBLAZE_ENDIANNESS 1
#define XPAR_MB_SS_0_MBLAZE_FAULT_TOLERANT 0
#define XPAR_MB_SS_0_MBLAZE_FPU_EXCEPTION 0
#define XPAR_MB_SS_0_MBLAZE_FREQ 100000000
#define XPAR_MB_SS_0_MBLAZE_FSL_EXCEPTION 0
#define XPAR_MB_SS_0_MBLAZE_FSL_LINKS 0
#define XPAR_MB_SS_0_MBLAZE_IADDR_SIZE 32
#define XPAR_MB_SS_0_MBLAZE_ICACHE_ALWAYS_USED 0
#define XPAR_MB_SS_0_MBLAZE_ICACHE_BASEADDR 0x00000000
#define XPAR_MB_SS_0_MBLAZE_ICACHE_DATA_WIDTH 0
#define XPAR_MB_SS_0_MBLAZE_ICACHE_FORCE_TAG_LUTRAM 0
#define XPAR_MB_SS_0_MBLAZE_ICACHE_HIGHADDR 0x3FFFFFFF
#define XPAR_MB_SS_0_MBLAZE_ICACHE_LINE_LEN 4
#define XPAR_MB_SS_0_MBLAZE_ICACHE_STREAMS 0
#define XPAR_MB_SS_0_MBLAZE_ICACHE_VICTIMS 0
#define XPAR_MB_SS_0_MBLAZE_IC_AXI_MON 0
#define XPAR_MB_SS_0_MBLAZE_ILL_OPCODE_EXCEPTION 0
#define XPAR_MB_SS_0_MBLAZE_IMPRECISE_EXCEPTIONS 0
#define XPAR_MB_SS_0_MBLAZE_INSTR_SIZE 32
#define XPAR_MB_SS_0_MBLAZE_INTERCONNECT 2
#define XPAR_MB_SS_0_MBLAZE_INTERRUPT_IS_EDGE 0
#define XPAR_MB_SS_0_MBLAZE_INTERRUPT_MON 0
#define XPAR_MB_SS_0_MBLAZE_IP_AXI_MON 0
#define XPAR_MB_SS_0_MBLAZE_I_AXI 0
#define XPAR_MB_SS_0_MBLAZE_I_LMB 1
#define XPAR_MB_SS_0_MBLAZE_I_LMB_MON 0
#define XPAR_MB_SS_0_MBLAZE_LOCKSTEP_MASTER 0
#define XPAR_MB_SS_0_MBLAZE_LOCKSTEP_SELECT 0
#define XPAR_MB_SS_0_MBLAZE_LOCKSTEP_SLAVE 0
#define XPAR_MB_SS_0_MBLAZE_M0_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M0_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_M1_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M1_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_M2_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M2_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_M3_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M3_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_M4_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M4_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_M5_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M5_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_M6_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M6_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_M7_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M7_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_M8_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M8_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_M9_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M9_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_M10_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M10_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_M11_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M11_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_M12_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M12_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_M13_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M13_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_M14_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M14_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_M15_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M15_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_MMU_DTLB_SIZE 4
#define XPAR_MB_SS_0_MBLAZE_MMU_ITLB_SIZE 2
#define XPAR_MB_SS_0_MBLAZE_MMU_PRIVILEGED_INSTR 0
#define XPAR_MB_SS_0_MBLAZE_MMU_TLB_ACCESS 3
#define XPAR_MB_SS_0_MBLAZE_MMU_ZONES 16
#define XPAR_MB_SS_0_MBLAZE_M_AXI_DC_ADDR_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M_AXI_DC_ARUSER_WIDTH 5
#define XPAR_MB_SS_0_MBLAZE_M_AXI_DC_AWUSER_WIDTH 5
#define XPAR_MB_SS_0_MBLAZE_M_AXI_DC_BUSER_WIDTH 1
#define XPAR_MB_SS_0_MBLAZE_M_AXI_DC_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M_AXI_DC_EXCLUSIVE_ACCESS 0
#define XPAR_MB_SS_0_MBLAZE_M_AXI_DC_RUSER_WIDTH 1
#define XPAR_MB_SS_0_MBLAZE_M_AXI_DC_THREAD_ID_WIDTH 1
#define XPAR_MB_SS_0_MBLAZE_M_AXI_DC_USER_SIGNALS 0
#define XPAR_MB_SS_0_MBLAZE_M_AXI_DC_USER_VALUE 31
#define XPAR_MB_SS_0_MBLAZE_M_AXI_DC_WUSER_WIDTH 1
#define XPAR_MB_SS_0_MBLAZE_M_AXI_DP_ADDR_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M_AXI_DP_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M_AXI_DP_EXCLUSIVE_ACCESS 0
#define XPAR_MB_SS_0_MBLAZE_M_AXI_DP_THREAD_ID_WIDTH 1
#define XPAR_MB_SS_0_MBLAZE_M_AXI_D_BUS_EXCEPTION 0
#define XPAR_MB_SS_0_MBLAZE_M_AXI_IC_ADDR_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M_AXI_IC_ARUSER_WIDTH 5
#define XPAR_MB_SS_0_MBLAZE_M_AXI_IC_AWUSER_WIDTH 5
#define XPAR_MB_SS_0_MBLAZE_M_AXI_IC_BUSER_WIDTH 1
#define XPAR_MB_SS_0_MBLAZE_M_AXI_IC_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M_AXI_IC_RUSER_WIDTH 1
#define XPAR_MB_SS_0_MBLAZE_M_AXI_IC_THREAD_ID_WIDTH 1
#define XPAR_MB_SS_0_MBLAZE_M_AXI_IC_USER_SIGNALS 0
#define XPAR_MB_SS_0_MBLAZE_M_AXI_IC_USER_VALUE 31
#define XPAR_MB_SS_0_MBLAZE_M_AXI_IC_WUSER_WIDTH 1
#define XPAR_MB_SS_0_MBLAZE_M_AXI_IP_ADDR_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M_AXI_IP_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_M_AXI_IP_THREAD_ID_WIDTH 1
#define XPAR_MB_SS_0_MBLAZE_M_AXI_I_BUS_EXCEPTION 0
#define XPAR_MB_SS_0_MBLAZE_NUMBER_OF_PC_BRK 1
#define XPAR_MB_SS_0_MBLAZE_NUMBER_OF_RD_ADDR_BRK 0
#define XPAR_MB_SS_0_MBLAZE_NUMBER_OF_WR_ADDR_BRK 0
#define XPAR_MB_SS_0_MBLAZE_NUM_SYNC_FF_CLK 2
#define XPAR_MB_SS_0_MBLAZE_NUM_SYNC_FF_CLK_DEBUG 2
#define XPAR_MB_SS_0_MBLAZE_NUM_SYNC_FF_CLK_IRQ 1
#define XPAR_MB_SS_0_MBLAZE_NUM_SYNC_FF_DBG_CLK 1
#define XPAR_MB_SS_0_MBLAZE_NUM_SYNC_FF_DBG_TRACE_CLK 2
#define XPAR_MB_SS_0_MBLAZE_OPCODE_0X0_ILLEGAL 0
#define XPAR_MB_SS_0_MBLAZE_OPTIMIZATION 0
#define XPAR_MB_SS_0_MBLAZE_PC_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_PIADDR_SIZE 32
#define XPAR_MB_SS_0_MBLAZE_PVR 0
#define XPAR_MB_SS_0_MBLAZE_PVR_USER1 0x00
#define XPAR_MB_SS_0_MBLAZE_PVR_USER2 0x00000000
#define XPAR_MB_SS_0_MBLAZE_RESET_MSR 0x00000000
#define XPAR_MB_SS_0_MBLAZE_RESET_MSR_BIP 0
#define XPAR_MB_SS_0_MBLAZE_RESET_MSR_DCE 0
#define XPAR_MB_SS_0_MBLAZE_RESET_MSR_EE 0
#define XPAR_MB_SS_0_MBLAZE_RESET_MSR_EIP 0
#define XPAR_MB_SS_0_MBLAZE_RESET_MSR_ICE 0
#define XPAR_MB_SS_0_MBLAZE_RESET_MSR_IE 0
#define XPAR_MB_SS_0_MBLAZE_S0_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_S0_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_S1_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_S1_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_S2_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_S2_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_S3_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_S3_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_S4_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_S4_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_S5_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_S5_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_S6_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_S6_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_S7_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_S7_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_S8_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_S8_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_S9_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_S9_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_S10_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_S10_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_S11_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_S11_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_S12_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_S12_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_S13_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_S13_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_S14_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_S14_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_S15_AXIS_DATA_WIDTH 32
#define XPAR_MB_SS_0_MBLAZE_S15_AXIS_PROTOCOL GENERIC
#define XPAR_MB_SS_0_MBLAZE_SCO 0
#define XPAR_MB_SS_0_MBLAZE_TRACE 0
#define XPAR_MB_SS_0_MBLAZE_UNALIGNED_EXCEPTIONS 0
#define XPAR_MB_SS_0_MBLAZE_USE_BARREL 0
#define XPAR_MB_SS_0_MBLAZE_USE_BRANCH_TARGET_CACHE 0
#define XPAR_MB_SS_0_MBLAZE_USE_CONFIG_RESET 0
#define XPAR_MB_SS_0_MBLAZE_USE_DCACHE 0
#define XPAR_MB_SS_0_MBLAZE_USE_DIV 0
#define XPAR_MB_SS_0_MBLAZE_USE_EXTENDED_FSL_INSTR 0
#define XPAR_MB_SS_0_MBLAZE_USE_EXT_BRK 0
#define XPAR_MB_SS_0_MBLAZE_USE_EXT_NM_BRK 0
#define XPAR_MB_SS_0_MBLAZE_USE_FPU 0
#define XPAR_MB_SS_0_MBLAZE_USE_HW_MUL 0
#define XPAR_MB_SS_0_MBLAZE_USE_ICACHE 0
#define XPAR_MB_SS_0_MBLAZE_USE_INTERRUPT 1
#define XPAR_MB_SS_0_MBLAZE_USE_MMU 0
#define XPAR_MB_SS_0_MBLAZE_USE_MSR_INSTR 0
#define XPAR_MB_SS_0_MBLAZE_USE_NON_SECURE 0
#define XPAR_MB_SS_0_MBLAZE_USE_PCMP_INSTR 0
#define XPAR_MB_SS_0_MBLAZE_USE_REORDER_INSTR 1
#define XPAR_MB_SS_0_MBLAZE_USE_STACK_PROTECTION 0
#define XPAR_MB_SS_0_MBLAZE_COMPONENT_NAME exdes_mblaze_0
#define XPAR_MB_SS_0_MBLAZE_EDK_IPTYPE PROCESSOR
#define XPAR_MB_SS_0_MBLAZE_EDK_SPECIAL microblaze
#define XPAR_MB_SS_0_MBLAZE_G_TEMPLATE_LIST 0
#define XPAR_MB_SS_0_MBLAZE_G_USE_EXCEPTIONS 0

/******************************************************************/

#define XPAR_CPU_ID 0
#define XPAR_MICROBLAZE_ID 0
#define XPAR_MICROBLAZE_ADDR_SIZE 32
#define XPAR_MICROBLAZE_ADDR_TAG_BITS 17
#define XPAR_MICROBLAZE_ALLOW_DCACHE_WR 1
#define XPAR_MICROBLAZE_ALLOW_ICACHE_WR 1
#define XPAR_MICROBLAZE_AREA_OPTIMIZED 0
#define XPAR_MICROBLAZE_ASYNC_INTERRUPT 1
#define XPAR_MICROBLAZE_ASYNC_WAKEUP 3
#define XPAR_MICROBLAZE_AVOID_PRIMITIVES 0
#define XPAR_MICROBLAZE_BASE_VECTORS 0x0000000000000000
#define XPAR_MICROBLAZE_BRANCH_TARGET_CACHE_SIZE 0
#define XPAR_MICROBLAZE_CACHE_BYTE_SIZE 8192
#define XPAR_MICROBLAZE_DADDR_SIZE 32
#define XPAR_MICROBLAZE_DATA_SIZE 32
#define XPAR_MICROBLAZE_DCACHE_ADDR_TAG 17
#define XPAR_MICROBLAZE_DCACHE_ALWAYS_USED 0
#define XPAR_MICROBLAZE_DCACHE_BASEADDR 0x00000000
#define XPAR_MICROBLAZE_DCACHE_BYTE_SIZE 8192
#define XPAR_MICROBLAZE_DCACHE_DATA_WIDTH 0
#define XPAR_MICROBLAZE_DCACHE_FORCE_TAG_LUTRAM 0
#define XPAR_MICROBLAZE_DCACHE_HIGHADDR 0x3FFFFFFF
#define XPAR_MICROBLAZE_DCACHE_LINE_LEN 4
#define XPAR_MICROBLAZE_DCACHE_USE_WRITEBACK 0
#define XPAR_MICROBLAZE_DCACHE_VICTIMS 0
#define XPAR_MICROBLAZE_DC_AXI_MON 0
#define XPAR_MICROBLAZE_DEBUG_COUNTER_WIDTH 32
#define XPAR_MICROBLAZE_DEBUG_ENABLED 1
#define XPAR_MICROBLAZE_DEBUG_EVENT_COUNTERS 5
#define XPAR_MICROBLAZE_DEBUG_EXTERNAL_TRACE 0
#define XPAR_MICROBLAZE_DEBUG_INTERFACE 0
#define XPAR_MICROBLAZE_DEBUG_LATENCY_COUNTERS 1
#define XPAR_MICROBLAZE_DEBUG_PROFILE_SIZE 0
#define XPAR_MICROBLAZE_DEBUG_TRACE_ASYNC_RESET 0
#define XPAR_MICROBLAZE_DEBUG_TRACE_SIZE 8192
#define XPAR_MICROBLAZE_DIV_ZERO_EXCEPTION 0
#define XPAR_MICROBLAZE_DP_AXI_MON 0
#define XPAR_MICROBLAZE_DYNAMIC_BUS_SIZING 0
#define XPAR_MICROBLAZE_D_AXI 1
#define XPAR_MICROBLAZE_D_LMB 1
#define XPAR_MICROBLAZE_D_LMB_MON 0
#define XPAR_MICROBLAZE_ECC_USE_CE_EXCEPTION 0
#define XPAR_MICROBLAZE_EDGE_IS_POSITIVE 1
#define XPAR_MICROBLAZE_ENABLE_DISCRETE_PORTS 0
#define XPAR_MICROBLAZE_ENDIANNESS 1
#define XPAR_MICROBLAZE_FAULT_TOLERANT 0
#define XPAR_MICROBLAZE_FPU_EXCEPTION 0
#define XPAR_MICROBLAZE_FREQ 100000000
#define XPAR_MICROBLAZE_FSL_EXCEPTION 0
#define XPAR_MICROBLAZE_FSL_LINKS 0
#define XPAR_MICROBLAZE_IADDR_SIZE 32
#define XPAR_MICROBLAZE_ICACHE_ALWAYS_USED 0
#define XPAR_MICROBLAZE_ICACHE_BASEADDR 0x00000000
#define XPAR_MICROBLAZE_ICACHE_DATA_WIDTH 0
#define XPAR_MICROBLAZE_ICACHE_FORCE_TAG_LUTRAM 0
#define XPAR_MICROBLAZE_ICACHE_HIGHADDR 0x3FFFFFFF
#define XPAR_MICROBLAZE_ICACHE_LINE_LEN 4
#define XPAR_MICROBLAZE_ICACHE_STREAMS 0
#define XPAR_MICROBLAZE_ICACHE_VICTIMS 0
#define XPAR_MICROBLAZE_IC_AXI_MON 0
#define XPAR_MICROBLAZE_ILL_OPCODE_EXCEPTION 0
#define XPAR_MICROBLAZE_IMPRECISE_EXCEPTIONS 0
#define XPAR_MICROBLAZE_INSTR_SIZE 32
#define XPAR_MICROBLAZE_INTERCONNECT 2
#define XPAR_MICROBLAZE_INTERRUPT_IS_EDGE 0
#define XPAR_MICROBLAZE_INTERRUPT_MON 0
#define XPAR_MICROBLAZE_IP_AXI_MON 0
#define XPAR_MICROBLAZE_I_AXI 0
#define XPAR_MICROBLAZE_I_LMB 1
#define XPAR_MICROBLAZE_I_LMB_MON 0
#define XPAR_MICROBLAZE_LOCKSTEP_MASTER 0
#define XPAR_MICROBLAZE_LOCKSTEP_SELECT 0
#define XPAR_MICROBLAZE_LOCKSTEP_SLAVE 0
#define XPAR_MICROBLAZE_M0_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M0_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_M1_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M1_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_M2_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M2_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_M3_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M3_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_M4_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M4_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_M5_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M5_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_M6_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M6_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_M7_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M7_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_M8_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M8_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_M9_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M9_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_M10_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M10_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_M11_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M11_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_M12_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M12_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_M13_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M13_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_M14_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M14_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_M15_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M15_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_MMU_DTLB_SIZE 4
#define XPAR_MICROBLAZE_MMU_ITLB_SIZE 2
#define XPAR_MICROBLAZE_MMU_PRIVILEGED_INSTR 0
#define XPAR_MICROBLAZE_MMU_TLB_ACCESS 3
#define XPAR_MICROBLAZE_MMU_ZONES 16
#define XPAR_MICROBLAZE_M_AXI_DC_ADDR_WIDTH 32
#define XPAR_MICROBLAZE_M_AXI_DC_ARUSER_WIDTH 5
#define XPAR_MICROBLAZE_M_AXI_DC_AWUSER_WIDTH 5
#define XPAR_MICROBLAZE_M_AXI_DC_BUSER_WIDTH 1
#define XPAR_MICROBLAZE_M_AXI_DC_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M_AXI_DC_EXCLUSIVE_ACCESS 0
#define XPAR_MICROBLAZE_M_AXI_DC_RUSER_WIDTH 1
#define XPAR_MICROBLAZE_M_AXI_DC_THREAD_ID_WIDTH 1
#define XPAR_MICROBLAZE_M_AXI_DC_USER_SIGNALS 0
#define XPAR_MICROBLAZE_M_AXI_DC_USER_VALUE 31
#define XPAR_MICROBLAZE_M_AXI_DC_WUSER_WIDTH 1
#define XPAR_MICROBLAZE_M_AXI_DP_ADDR_WIDTH 32
#define XPAR_MICROBLAZE_M_AXI_DP_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M_AXI_DP_EXCLUSIVE_ACCESS 0
#define XPAR_MICROBLAZE_M_AXI_DP_THREAD_ID_WIDTH 1
#define XPAR_MICROBLAZE_M_AXI_D_BUS_EXCEPTION 0
#define XPAR_MICROBLAZE_M_AXI_IC_ADDR_WIDTH 32
#define XPAR_MICROBLAZE_M_AXI_IC_ARUSER_WIDTH 5
#define XPAR_MICROBLAZE_M_AXI_IC_AWUSER_WIDTH 5
#define XPAR_MICROBLAZE_M_AXI_IC_BUSER_WIDTH 1
#define XPAR_MICROBLAZE_M_AXI_IC_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M_AXI_IC_RUSER_WIDTH 1
#define XPAR_MICROBLAZE_M_AXI_IC_THREAD_ID_WIDTH 1
#define XPAR_MICROBLAZE_M_AXI_IC_USER_SIGNALS 0
#define XPAR_MICROBLAZE_M_AXI_IC_USER_VALUE 31
#define XPAR_MICROBLAZE_M_AXI_IC_WUSER_WIDTH 1
#define XPAR_MICROBLAZE_M_AXI_IP_ADDR_WIDTH 32
#define XPAR_MICROBLAZE_M_AXI_IP_DATA_WIDTH 32
#define XPAR_MICROBLAZE_M_AXI_IP_THREAD_ID_WIDTH 1
#define XPAR_MICROBLAZE_M_AXI_I_BUS_EXCEPTION 0
#define XPAR_MICROBLAZE_NUMBER_OF_PC_BRK 1
#define XPAR_MICROBLAZE_NUMBER_OF_RD_ADDR_BRK 0
#define XPAR_MICROBLAZE_NUMBER_OF_WR_ADDR_BRK 0
#define XPAR_MICROBLAZE_NUM_SYNC_FF_CLK 2
#define XPAR_MICROBLAZE_NUM_SYNC_FF_CLK_DEBUG 2
#define XPAR_MICROBLAZE_NUM_SYNC_FF_CLK_IRQ 1
#define XPAR_MICROBLAZE_NUM_SYNC_FF_DBG_CLK 1
#define XPAR_MICROBLAZE_NUM_SYNC_FF_DBG_TRACE_CLK 2
#define XPAR_MICROBLAZE_OPCODE_0X0_ILLEGAL 0
#define XPAR_MICROBLAZE_OPTIMIZATION 0
#define XPAR_MICROBLAZE_PC_WIDTH 32
#define XPAR_MICROBLAZE_PIADDR_SIZE 32
#define XPAR_MICROBLAZE_PVR 0
#define XPAR_MICROBLAZE_PVR_USER1 0x00
#define XPAR_MICROBLAZE_PVR_USER2 0x00000000
#define XPAR_MICROBLAZE_RESET_MSR 0x00000000
#define XPAR_MICROBLAZE_RESET_MSR_BIP 0
#define XPAR_MICROBLAZE_RESET_MSR_DCE 0
#define XPAR_MICROBLAZE_RESET_MSR_EE 0
#define XPAR_MICROBLAZE_RESET_MSR_EIP 0
#define XPAR_MICROBLAZE_RESET_MSR_ICE 0
#define XPAR_MICROBLAZE_RESET_MSR_IE 0
#define XPAR_MICROBLAZE_S0_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_S0_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_S1_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_S1_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_S2_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_S2_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_S3_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_S3_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_S4_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_S4_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_S5_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_S5_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_S6_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_S6_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_S7_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_S7_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_S8_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_S8_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_S9_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_S9_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_S10_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_S10_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_S11_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_S11_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_S12_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_S12_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_S13_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_S13_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_S14_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_S14_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_S15_AXIS_DATA_WIDTH 32
#define XPAR_MICROBLAZE_S15_AXIS_PROTOCOL GENERIC
#define XPAR_MICROBLAZE_SCO 0
#define XPAR_MICROBLAZE_TRACE 0
#define XPAR_MICROBLAZE_UNALIGNED_EXCEPTIONS 0
#define XPAR_MICROBLAZE_USE_BARREL 0
#define XPAR_MICROBLAZE_USE_BRANCH_TARGET_CACHE 0
#define XPAR_MICROBLAZE_USE_CONFIG_RESET 0
#define XPAR_MICROBLAZE_USE_DCACHE 0
#define XPAR_MICROBLAZE_USE_DIV 0
#define XPAR_MICROBLAZE_USE_EXTENDED_FSL_INSTR 0
#define XPAR_MICROBLAZE_USE_EXT_BRK 0
#define XPAR_MICROBLAZE_USE_EXT_NM_BRK 0
#define XPAR_MICROBLAZE_USE_FPU 0
#define XPAR_MICROBLAZE_USE_HW_MUL 0
#define XPAR_MICROBLAZE_USE_ICACHE 0
#define XPAR_MICROBLAZE_USE_INTERRUPT 1
#define XPAR_MICROBLAZE_USE_MMU 0
#define XPAR_MICROBLAZE_USE_MSR_INSTR 0
#define XPAR_MICROBLAZE_USE_NON_SECURE 0
#define XPAR_MICROBLAZE_USE_PCMP_INSTR 0
#define XPAR_MICROBLAZE_USE_REORDER_INSTR 1
#define XPAR_MICROBLAZE_USE_STACK_PROTECTION 0
#define XPAR_MICROBLAZE_COMPONENT_NAME exdes_mblaze_0
#define XPAR_MICROBLAZE_EDK_IPTYPE PROCESSOR
#define XPAR_MICROBLAZE_EDK_SPECIAL microblaze
#define XPAR_MICROBLAZE_G_TEMPLATE_LIST 0
#define XPAR_MICROBLAZE_G_USE_EXCEPTIONS 0

/******************************************************************/

#ifdef XILINX_MCU_EXIST //AVerMedia_Jeff_20190313
#define STDIN_BASEADDRESS 0x40600000
#define STDOUT_BASEADDRESS 0x40600000
#else
#define STDIN_BASEADDRESS 0x00190000
#define STDOUT_BASEADDRESS 0x00190000
#endif

/******************************************************************/

/* Platform specific definitions */
#define PLATFORM_MB
 
/* Definitions for sleep timer configuration */
#define XSLEEP_TIMER_IS_DEFAULT_TIMER
 
 
/******************************************************************/
/* Definitions for driver BRAM */
#define XPAR_XBRAM_NUM_INSTANCES 2U

/* Definitions for peripheral MB_SS_0_DLMB_BRAM_IF_CNTLR */
#define XPAR_MB_SS_0_DLMB_BRAM_IF_CNTLR_DEVICE_ID 0U
#define XPAR_MB_SS_0_DLMB_BRAM_IF_CNTLR_DATA_WIDTH 32U
#define XPAR_MB_SS_0_DLMB_BRAM_IF_CNTLR_ECC 0U
#define XPAR_MB_SS_0_DLMB_BRAM_IF_CNTLR_FAULT_INJECT 0U
#define XPAR_MB_SS_0_DLMB_BRAM_IF_CNTLR_CE_FAILING_REGISTERS 0U
#define XPAR_MB_SS_0_DLMB_BRAM_IF_CNTLR_UE_FAILING_REGISTERS 0U
#define XPAR_MB_SS_0_DLMB_BRAM_IF_CNTLR_ECC_STATUS_REGISTERS 0U
#define XPAR_MB_SS_0_DLMB_BRAM_IF_CNTLR_CE_COUNTER_WIDTH 0U
#define XPAR_MB_SS_0_DLMB_BRAM_IF_CNTLR_ECC_ONOFF_REGISTER 0U
#define XPAR_MB_SS_0_DLMB_BRAM_IF_CNTLR_ECC_ONOFF_RESET_VALUE 1U
#define XPAR_MB_SS_0_DLMB_BRAM_IF_CNTLR_WRITE_ACCESS 2U
#define XPAR_MB_SS_0_DLMB_BRAM_IF_CNTLR_BASEADDR 0x00000000U
#define XPAR_MB_SS_0_DLMB_BRAM_IF_CNTLR_HIGHADDR 0x0003FFFFU
#define XPAR_MB_SS_0_DLMB_BRAM_IF_CNTLR_S_AXI_CTRL_BASEADDR 0xFFFFFFFFU 
#define XPAR_MB_SS_0_DLMB_BRAM_IF_CNTLR_S_AXI_CTRL_HIGHADDR 0xFFFFFFFFU 


/* Definitions for peripheral MB_SS_0_ILMB_BRAM_IF_CNTLR */
#define XPAR_MB_SS_0_ILMB_BRAM_IF_CNTLR_DEVICE_ID 1U
#define XPAR_MB_SS_0_ILMB_BRAM_IF_CNTLR_DATA_WIDTH 32U
#define XPAR_MB_SS_0_ILMB_BRAM_IF_CNTLR_ECC 0U
#define XPAR_MB_SS_0_ILMB_BRAM_IF_CNTLR_FAULT_INJECT 0U
#define XPAR_MB_SS_0_ILMB_BRAM_IF_CNTLR_CE_FAILING_REGISTERS 0U
#define XPAR_MB_SS_0_ILMB_BRAM_IF_CNTLR_UE_FAILING_REGISTERS 0U
#define XPAR_MB_SS_0_ILMB_BRAM_IF_CNTLR_ECC_STATUS_REGISTERS 0U
#define XPAR_MB_SS_0_ILMB_BRAM_IF_CNTLR_CE_COUNTER_WIDTH 0U
#define XPAR_MB_SS_0_ILMB_BRAM_IF_CNTLR_ECC_ONOFF_REGISTER 0U
#define XPAR_MB_SS_0_ILMB_BRAM_IF_CNTLR_ECC_ONOFF_RESET_VALUE 1U
#define XPAR_MB_SS_0_ILMB_BRAM_IF_CNTLR_WRITE_ACCESS 2U
#define XPAR_MB_SS_0_ILMB_BRAM_IF_CNTLR_BASEADDR 0x00000000U
#define XPAR_MB_SS_0_ILMB_BRAM_IF_CNTLR_HIGHADDR 0x0003FFFFU
#define XPAR_MB_SS_0_ILMB_BRAM_IF_CNTLR_S_AXI_CTRL_BASEADDR 0xFFFFFFFFU 
#define XPAR_MB_SS_0_ILMB_BRAM_IF_CNTLR_S_AXI_CTRL_HIGHADDR 0xFFFFFFFFU 


/******************************************************************/

/* Canonical definitions for peripheral MB_SS_0_DLMB_BRAM_IF_CNTLR */
#define XPAR_BRAM_0_DEVICE_ID XPAR_MB_SS_0_DLMB_BRAM_IF_CNTLR_DEVICE_ID
#define XPAR_BRAM_0_DATA_WIDTH 32U
#define XPAR_BRAM_0_ECC 0U
#define XPAR_BRAM_0_FAULT_INJECT 0U
#define XPAR_BRAM_0_CE_FAILING_REGISTERS 0U
#define XPAR_BRAM_0_UE_FAILING_REGISTERS 0U
#define XPAR_BRAM_0_ECC_STATUS_REGISTERS 0U
#define XPAR_BRAM_0_CE_COUNTER_WIDTH 0U
#define XPAR_BRAM_0_ECC_ONOFF_REGISTER 0U
#define XPAR_BRAM_0_ECC_ONOFF_RESET_VALUE 1U
#define XPAR_BRAM_0_WRITE_ACCESS 2U
#define XPAR_BRAM_0_BASEADDR 0x00000000U
#define XPAR_BRAM_0_HIGHADDR 0x0003FFFFU

/* Canonical definitions for peripheral MB_SS_0_ILMB_BRAM_IF_CNTLR */
#define XPAR_BRAM_1_DEVICE_ID XPAR_MB_SS_0_ILMB_BRAM_IF_CNTLR_DEVICE_ID
#define XPAR_BRAM_1_DATA_WIDTH 32U
#define XPAR_BRAM_1_ECC 0U
#define XPAR_BRAM_1_FAULT_INJECT 0U
#define XPAR_BRAM_1_CE_FAILING_REGISTERS 0U
#define XPAR_BRAM_1_UE_FAILING_REGISTERS 0U
#define XPAR_BRAM_1_ECC_STATUS_REGISTERS 0U
#define XPAR_BRAM_1_CE_COUNTER_WIDTH 0U
#define XPAR_BRAM_1_ECC_ONOFF_REGISTER 0U
#define XPAR_BRAM_1_ECC_ONOFF_RESET_VALUE 1U
#define XPAR_BRAM_1_WRITE_ACCESS 2U
#define XPAR_BRAM_1_BASEADDR 0x00000000U
#define XPAR_BRAM_1_HIGHADDR 0x0003FFFFU


/******************************************************************/

/* Definitions for driver CLK_WIZ */
#define XPAR_XCLK_WIZ_NUM_INSTANCES 1

/* Definitions for peripheral AUDIO_SS_0_CLK_WIZ */
#define XPAR_AUDIO_SS_0_CLK_WIZ_DEVICE_ID 0
#ifdef XILINX_MCU_EXIST //AVerMedia_Jeff_20190313
#define XPAR_AUDIO_SS_0_CLK_WIZ_BASEADDR 0x44A10000
#define XPAR_AUDIO_SS_0_CLK_WIZ_HIGHADDR 0x44A1FFFF
#else
#define XPAR_AUDIO_SS_0_CLK_WIZ_BASEADDR 0x00150000
#define XPAR_AUDIO_SS_0_CLK_WIZ_HIGHADDR 0x0015FFFF
#endif
#define XPAR_AUDIO_SS_0_CLK_WIZ_ENABLE_CLOCK_MONITOR 0
#define XPAR_AUDIO_SS_0_CLK_WIZ_ENABLE_USER_CLOCK0 0
#define XPAR_AUDIO_SS_0_CLK_WIZ_ENABLE_USER_CLOCK1 0
#define XPAR_AUDIO_SS_0_CLK_WIZ_ENABLE_USER_CLOCK2 0
#define XPAR_AUDIO_SS_0_CLK_WIZ_ENABLE_USER_CLOCK3 0
#define XPAR_AUDIO_SS_0_CLK_WIZ_REF_CLK_FREQ 100.0
#define XPAR_AUDIO_SS_0_CLK_WIZ_USER_CLK_FREQ0 100.0
#define XPAR_AUDIO_SS_0_CLK_WIZ_USER_CLK_FREQ1 100.0
#define XPAR_AUDIO_SS_0_CLK_WIZ_USER_CLK_FREQ2 100.0
#define XPAR_AUDIO_SS_0_CLK_WIZ_USER_CLK_FREQ3 100.0
#define XPAR_AUDIO_SS_0_CLK_WIZ_PRECISION 1
#define XPAR_AUDIO_SS_0_CLK_WIZ_ENABLE_PLL0 0
#define XPAR_AUDIO_SS_0_CLK_WIZ_ENABLE_PLL1 0


/******************************************************************/

/* Canonical definitions for peripheral AUDIO_SS_0_CLK_WIZ */
#define XPAR_CLK_WIZ_0_DEVICE_ID XPAR_AUDIO_SS_0_CLK_WIZ_DEVICE_ID
#define XPAR_CLK_WIZ_0_BASEADDR XPAR_AUDIO_SS_0_CLK_WIZ_BASEADDR
#define XPAR_CLK_WIZ_0_HIGHADDR XPAR_AUDIO_SS_0_CLK_WIZ_HIGHADDR
#define XPAR_CLK_WIZ_0_ENABLE_CLOCK_MONITOR 0
#define XPAR_CLK_WIZ_0_ENABLE_USER_CLOCK0 0
#define XPAR_CLK_WIZ_0_ENABLE_USER_CLOCK1 0
#define XPAR_CLK_WIZ_0_ENABLE_USER_CLOCK2 0
#define XPAR_CLK_WIZ_0_ENABLE_USER_CLOCK3 0
#define XPAR_CLK_WIZ_0_REF_CLK_FREQ 100.0
#define XPAR_CLK_WIZ_0_USER_CLK_FREQ0 100.0
#define XPAR_CLK_WIZ_0_USER_CLK_FREQ1 100.0
#define XPAR_CLK_WIZ_0_USER_CLK_FREQ2 100.0
#define XPAR_CLK_WIZ_0_USER_CLK_FREQ3 100.0
#define XPAR_CLK_WIZ_0_PRECISION 1
#define XPAR_CLK_WIZ_0_Enable_PLL0 0
#define XPAR_CLK_WIZ_0_Enable_PLL1 0


/******************************************************************/


/* Definitions for peripheral AUDIO_SS_0_AUD_PAT_GEN */
#ifdef XILINX_MCU_EXIST //AVerMedia_Jeff_20190313
#define XPAR_AUDIO_SS_0_AUD_PAT_GEN_BASEADDR 0x80000000
#define XPAR_AUDIO_SS_0_AUD_PAT_GEN_HIGHADDR 0x8000FFFF
#else
#define XPAR_AUDIO_SS_0_AUD_PAT_GEN_BASEADDR 0x00140000
#define XPAR_AUDIO_SS_0_AUD_PAT_GEN_HIGHADDR 0x0014FFFF
#endif


/* Definitions for peripheral AUDIO_SS_0_HDMI_ACR_CTRL */
#ifdef XILINX_MCU_EXIST //AVerMedia_Jeff_20190313
#define XPAR_AUDIO_SS_0_HDMI_ACR_CTRL_BASEADDR 0xC0000000
#define XPAR_AUDIO_SS_0_HDMI_ACR_CTRL_HIGHADDR 0xC000FFFF
#else
#define XPAR_AUDIO_SS_0_HDMI_ACR_CTRL_BASEADDR 0x00160000
#define XPAR_AUDIO_SS_0_HDMI_ACR_CTRL_HIGHADDR 0x0016FFFF
#endif


/******************************************************************/

/* Definitions for driver GPIO */
#define XPAR_XGPIO_NUM_INSTANCES 1

/* Definitions for peripheral V_TPG_SS_0_AXI_GPIO */
#ifdef XILINX_MCU_EXIST //AVerMedia_Jeff_20190313
#define XPAR_V_TPG_SS_0_AXI_GPIO_BASEADDR 0x40000000
#define XPAR_V_TPG_SS_0_AXI_GPIO_HIGHADDR 0x4000FFFF
#else
#define XPAR_V_TPG_SS_0_AXI_GPIO_BASEADDR 0x001A0000
#define XPAR_V_TPG_SS_0_AXI_GPIO_HIGHADDR 0x001AFFFF
#endif
#define XPAR_V_TPG_SS_0_AXI_GPIO_DEVICE_ID 0
#define XPAR_V_TPG_SS_0_AXI_GPIO_INTERRUPT_PRESENT 0
#define XPAR_V_TPG_SS_0_AXI_GPIO_IS_DUAL 0


/******************************************************************/

/* Canonical definitions for peripheral V_TPG_SS_0_AXI_GPIO */
#define XPAR_GPIO_0_BASEADDR XPAR_V_TPG_SS_0_AXI_GPIO_BASEADDR
#define XPAR_GPIO_0_HIGHADDR XPAR_V_TPG_SS_0_AXI_GPIO_HIGHADDR
#define XPAR_GPIO_0_DEVICE_ID XPAR_V_TPG_SS_0_AXI_GPIO_DEVICE_ID
#define XPAR_GPIO_0_INTERRUPT_PRESENT 0
#define XPAR_GPIO_0_IS_DUAL 0


/******************************************************************/

/* Definitions for driver IIC */
#define XPAR_XIIC_NUM_INSTANCES 1

/* Definitions for peripheral MB_SS_0_FMCH_AXI_IIC */
#define XPAR_MB_SS_0_FMCH_AXI_IIC_DEVICE_ID 0
#ifdef XILINX_MCU_EXIST //AVerMedia_Jeff_20190313
#define XPAR_MB_SS_0_FMCH_AXI_IIC_BASEADDR 0x40800000
#define XPAR_MB_SS_0_FMCH_AXI_IIC_HIGHADDR 0x4080FFFF
#else
#define XPAR_MB_SS_0_FMCH_AXI_IIC_BASEADDR 0x00180000
#define XPAR_MB_SS_0_FMCH_AXI_IIC_HIGHADDR 0x0018FFFF
#endif
#define XPAR_MB_SS_0_FMCH_AXI_IIC_TEN_BIT_ADR 0
#define XPAR_MB_SS_0_FMCH_AXI_IIC_GPO_WIDTH 1


/******************************************************************/

/* Canonical definitions for peripheral MB_SS_0_FMCH_AXI_IIC */
#define XPAR_IIC_0_DEVICE_ID XPAR_MB_SS_0_FMCH_AXI_IIC_DEVICE_ID
#define XPAR_IIC_0_BASEADDR XPAR_MB_SS_0_FMCH_AXI_IIC_BASEADDR
#define XPAR_IIC_0_HIGHADDR XPAR_MB_SS_0_FMCH_AXI_IIC_HIGHADDR
#define XPAR_IIC_0_TEN_BIT_ADR 0
#define XPAR_IIC_0_GPO_WIDTH 1


/******************************************************************/

#if 0 //AVerMedia_Jeff: Fixed BSOD during restart driver
#define XPAR_INTC_MAX_NUM_INTR_INPUTS 3
#else
#define XPAR_INTC_MAX_NUM_INTR_INPUTS 2
#endif
#define XPAR_XINTC_HAS_IPR 1
#define XPAR_XINTC_HAS_SIE 1
#define XPAR_XINTC_HAS_CIE 1
#define XPAR_XINTC_HAS_IVR 1
/* Definitions for driver INTC */
#define XPAR_XINTC_NUM_INSTANCES 1

/* Definitions for peripheral MB_SS_0_AXI_INTC */
#define XPAR_MB_SS_0_AXI_INTC_DEVICE_ID 0
#ifdef XILINX_MCU_EXIST //AVerMedia_Jeff_20190313
#define XPAR_MB_SS_0_AXI_INTC_BASEADDR 0x41200000
#define XPAR_MB_SS_0_AXI_INTC_HIGHADDR 0x4120FFFF
#else
#define XPAR_MB_SS_0_AXI_INTC_BASEADDR 0x00170000
#define XPAR_MB_SS_0_AXI_INTC_HIGHADDR 0x0017FFFF
#endif
#if 0 //AVerMedia_Jeff: Fixed BSOD during restart driver
#define XPAR_MB_SS_0_AXI_INTC_KIND_OF_INTR 0xFFFFFFF8
#else
#define XPAR_MB_SS_0_AXI_INTC_KIND_OF_INTR 0xFFFFFFFC
#endif
#define XPAR_MB_SS_0_AXI_INTC_HAS_FAST 0
#define XPAR_MB_SS_0_AXI_INTC_IVAR_RESET_VALUE 0x00000010
#if 0 //AVerMedia_Jeff: Fixed BSOD during restart driver
#define XPAR_MB_SS_0_AXI_INTC_NUM_INTR_INPUTS 3
#else
#define XPAR_MB_SS_0_AXI_INTC_NUM_INTR_INPUTS 2
#endif


/******************************************************************/

#define XPAR_INTC_SINGLE_BASEADDR XPAR_MB_SS_0_AXI_INTC_BASEADDR
#define XPAR_INTC_SINGLE_HIGHADDR XPAR_MB_SS_0_AXI_INTC_HIGHADDR
#define XPAR_INTC_SINGLE_DEVICE_ID XPAR_MB_SS_0_AXI_INTC_DEVICE_ID
#define XPAR_MB_SS_0_AXI_INTC_TYPE 0U
#define XPAR_VID_PHY_CONTROLLER_IRQ_MASK 0X000001U
#define XPAR_MB_SS_0_AXI_INTC_VID_PHY_CONTROLLER_IRQ_INTR 0U
#define XPAR_V_HDMI_RX_SS_IRQ_MASK 0X000002U
#define XPAR_MB_SS_0_AXI_INTC_V_HDMI_RX_SS_IRQ_INTR 1U
#define XPAR_V_HDMI_TX_SS_IRQ_MASK 0X000004U
#define XPAR_MB_SS_0_AXI_INTC_V_HDMI_TX_SS_IRQ_INTR 2U

/******************************************************************/

/* Canonical definitions for peripheral MB_SS_0_AXI_INTC */
#define XPAR_INTC_0_DEVICE_ID XPAR_MB_SS_0_AXI_INTC_DEVICE_ID
#define XPAR_INTC_0_BASEADDR XPAR_MB_SS_0_AXI_INTC_BASEADDR
#define XPAR_INTC_0_HIGHADDR XPAR_MB_SS_0_AXI_INTC_HIGHADDR
#define XPAR_INTC_0_KIND_OF_INTR 0xFFFFFFF8
#define XPAR_INTC_0_HAS_FAST 0
#define XPAR_INTC_0_IVAR_RESET_VALUE 0x00000010
#define XPAR_INTC_0_NUM_INTR_INPUTS 3
#define XPAR_INTC_0_INTC_TYPE 0

#define XPAR_INTC_0_VPHY_0_VEC_ID XPAR_MB_SS_0_AXI_INTC_VID_PHY_CONTROLLER_IRQ_INTR
#define XPAR_INTC_0_V_HDMIRXSS_0_VEC_ID XPAR_MB_SS_0_AXI_INTC_V_HDMI_RX_SS_IRQ_INTR
#define XPAR_INTC_0_V_HDMITXSS_0_VEC_ID XPAR_MB_SS_0_AXI_INTC_V_HDMI_TX_SS_IRQ_INTR

/******************************************************************/

/* Definitions for driver UARTLITE */
#define XPAR_XUARTLITE_NUM_INSTANCES 1

/* Definitions for peripheral MB_SS_0_AXI_UARTLITE */
#ifdef XILINX_MCU_EXIST //AVerMedia_Jeff_20190313
#define XPAR_MB_SS_0_AXI_UARTLITE_BASEADDR 0x40600000
#define XPAR_MB_SS_0_AXI_UARTLITE_HIGHADDR 0x4060FFFF
#else
#define XPAR_MB_SS_0_AXI_UARTLITE_BASEADDR 0x00190000
#define XPAR_MB_SS_0_AXI_UARTLITE_HIGHADDR 0x0019FFFF
#endif
#define XPAR_MB_SS_0_AXI_UARTLITE_DEVICE_ID 0
#define XPAR_MB_SS_0_AXI_UARTLITE_BAUDRATE 115200
#define XPAR_MB_SS_0_AXI_UARTLITE_USE_PARITY 0
#define XPAR_MB_SS_0_AXI_UARTLITE_ODD_PARITY 0
#define XPAR_MB_SS_0_AXI_UARTLITE_DATA_BITS 8


/******************************************************************/

/* Canonical definitions for peripheral MB_SS_0_AXI_UARTLITE */
#define XPAR_UARTLITE_0_DEVICE_ID XPAR_MB_SS_0_AXI_UARTLITE_DEVICE_ID
#define XPAR_UARTLITE_0_BASEADDR XPAR_MB_SS_0_AXI_UARTLITE_BASEADDR
#define XPAR_UARTLITE_0_HIGHADDR XPAR_MB_SS_0_AXI_UARTLITE_HIGHADDR
#define XPAR_UARTLITE_0_BAUDRATE 115200
#define XPAR_UARTLITE_0_USE_PARITY 0
#define XPAR_UARTLITE_0_ODD_PARITY 0
#define XPAR_UARTLITE_0_DATA_BITS 8


/******************************************************************/

/* Definitions for driver V_HDMIRX */
#define XPAR_XV_HDMIRX_NUM_INSTANCES 1

/* Definitions for peripheral V_HDMI_RX_SS_V_HDMI_RX */
#define XPAR_V_HDMI_RX_SS_V_HDMI_RX_DEVICE_ID 0
#define XPAR_V_HDMI_RX_SS_V_HDMI_RX_BASEADDR 0x00000000
#define XPAR_V_HDMI_RX_SS_V_HDMI_RX_HIGHADDR 0x0000FFFF
#define XPAR_V_HDMI_RX_SS_V_HDMI_RX_AXI_LITE_FREQ_HZ 100000000


/******************************************************************/

/* Canonical definitions for peripheral V_HDMI_RX_SS_V_HDMI_RX */
#define XPAR_XV_HDMIRX_0_NUM_INSTANCES 0
#define XPAR_XV_HDMIRX_0_DEVICE_ID XPAR_V_HDMI_RX_SS_V_HDMI_RX_DEVICE_ID
#define XPAR_XV_HDMIRX_0_BASEADDR 0x00000000
#define XPAR_XV_HDMIRX_0_HIGHADDR 0x0000FFFF
#define XPAR_XV_HDMIRX_0_AXI_LITE_FREQ_HZ 100000000


/******************************************************************/

/* Definitions for driver V_HDMIRXSS */
#define XPAR_XV_HDMIRXSS_NUM_INSTANCES 1

/* Definitions for peripheral V_HDMI_RX_SS */
#ifdef XILINX_MCU_EXIST
#define XPAR_V_HDMI_RX_SS_BASEADDR 0x44A00000
#define XPAR_V_HDMI_RX_SS_HIGHADDR 0x44A0FFFF
#else
#define XPAR_V_HDMI_RX_SS_BASEADDR 0x00110000
#define XPAR_V_HDMI_RX_SS_HIGHADDR 0x0011FFFF
#endif
#define XPAR_V_HDMI_RX_SS_DEVICE_ID 0
#define XPAR_V_HDMI_RX_SS_INPUT_PIXELS_PER_CLOCK 2
#define XPAR_V_HDMI_RX_SS_MAX_BITS_PER_COMPONENT 10


/******************************************************************/

/* Canonical definitions for peripheral V_HDMI_RX_SS */
#define XPAR_XV_HDMIRXSS_0_BASEADDR XPAR_V_HDMI_RX_SS_BASEADDR
#define XPAR_XV_HDMIRXSS_0_HIGHADDR XPAR_V_HDMI_RX_SS_HIGHADDR
#define XPAR_XV_HDMIRXSS_0_DEVICE_ID XPAR_V_HDMI_RX_SS_DEVICE_ID
#define XPAR_XV_HDMIRXSS_0_INPUT_PIXELS_PER_CLOCK 2
#define XPAR_XV_HDMIRXSS_0_MAX_BITS_PER_COMPONENT 8


/******************************************************************/

/* Definitions for driver V_HDMITX */
#define XPAR_XV_HDMITX_NUM_INSTANCES 1

/* Definitions for peripheral V_HDMI_TX_SS_V_HDMI_TX */
#define XPAR_V_HDMI_TX_SS_V_HDMI_TX_DEVICE_ID 0
#define XPAR_V_HDMI_TX_SS_V_HDMI_TX_BASEADDR 0x00000000
#define XPAR_V_HDMI_TX_SS_V_HDMI_TX_HIGHADDR 0x0000FFFF
#define XPAR_V_HDMI_TX_SS_V_HDMI_TX_AXI_LITE_FREQ_HZ 100000000


/******************************************************************/

/* Canonical definitions for peripheral V_HDMI_TX_SS_V_HDMI_TX */
#define XPAR_XV_HDMITX_0_NUM_INSTANCES 0
#define XPAR_XV_HDMITX_0_DEVICE_ID XPAR_V_HDMI_TX_SS_V_HDMI_TX_DEVICE_ID
#define XPAR_XV_HDMITX_0_BASEADDR 0x00000000
#define XPAR_XV_HDMITX_0_HIGHADDR 0x0000FFFF
#define XPAR_XV_HDMITX_0_AXI_LITE_FREQ_HZ 100000000


/******************************************************************/

/* Definitions for driver V_HDMITXSS */
#define XPAR_XV_HDMITXSS_NUM_INSTANCES 1

/* Definitions for peripheral V_HDMI_TX_SS */
#ifdef XILINX_MCU_EXIST
#define XPAR_V_HDMI_TX_SS_BASEADDR 0x44A20000
#define XPAR_V_HDMI_TX_SS_HIGHADDR 0x44A3FFFF
#else
#define XPAR_V_HDMI_TX_SS_BASEADDR 0x00120000
#define XPAR_V_HDMI_TX_SS_HIGHADDR 0x0013FFFF
#endif
#define XPAR_V_HDMI_TX_SS_DEVICE_ID 0
#define XPAR_V_HDMI_TX_SS_INPUT_PIXELS_PER_CLOCK 2
#define XPAR_V_HDMI_TX_SS_MAX_BITS_PER_COMPONENT 8
#define XPAR_V_HDMI_TX_SS_INCLUDE_LOW_RESO_VID 0
#define XPAR_V_HDMI_TX_SS_INCLUDE_YUV420_SUP 0
#define XPAR_V_HDMI_TX_SS_AXI_LITE_FREQ_HZ 100000000


/******************************************************************/

/* Canonical definitions for peripheral V_HDMI_TX_SS */
#define XPAR_XV_HDMITXSS_0_BASEADDR XPAR_V_HDMI_TX_SS_BASEADDR
#define XPAR_XV_HDMITXSS_0_HIGHADDR XPAR_V_HDMI_TX_SS_HIGHADDR
#define XPAR_XV_HDMITXSS_0_DEVICE_ID 0
#define XPAR_XV_HDMITXSS_0_INPUT_PIXELS_PER_CLOCK 2
#define XPAR_XV_HDMITXSS_0_MAX_BITS_PER_COMPONENT 8
#define XPAR_XV_HDMITXSS_0_INCLUDE_LOW_RESO_VID 0
#define XPAR_XV_HDMITXSS_0_INCLUDE_YUV420_SUP 0
#define XPAR_XV_HDMITXSS_0_AXI_LITE_FREQ_HZ 100000000

/******************************************************************/

/* Definitions for driver V_TPG */
#define XPAR_XV_TPG_NUM_INSTANCES 1

/* Definitions for peripheral V_TPG_SS_0_V_TPG */
#define XPAR_V_TPG_SS_0_V_TPG_DEVICE_ID 0
#ifdef XILINX_MCU_EXIST
#define XPAR_V_TPG_SS_0_V_TPG_S_AXI_CTRL_BASEADDR 0x44A40000
#define XPAR_V_TPG_SS_0_V_TPG_S_AXI_CTRL_HIGHADDR 0x44A4FFFF
#else
#define XPAR_V_TPG_SS_0_V_TPG_S_AXI_CTRL_BASEADDR 0x001B0000
#define XPAR_V_TPG_SS_0_V_TPG_S_AXI_CTRL_HIGHADDR 0x001BFFFF
#endif
#define XPAR_V_TPG_SS_0_V_TPG_HAS_AXI4S_SLAVE 1
#define XPAR_V_TPG_SS_0_V_TPG_SAMPLES_PER_CLOCK 2
#define XPAR_V_TPG_SS_0_V_TPG_NUM_VIDEO_COMPONENTS 3
#define XPAR_V_TPG_SS_0_V_TPG_MAX_COLS 4096
#define XPAR_V_TPG_SS_0_V_TPG_MAX_ROWS 2160
#define XPAR_V_TPG_SS_0_V_TPG_MAX_DATA_WIDTH 8
#define XPAR_V_TPG_SS_0_V_TPG_SOLID_COLOR 0
#define XPAR_V_TPG_SS_0_V_TPG_RAMP 0
#define XPAR_V_TPG_SS_0_V_TPG_COLOR_BAR 1
#define XPAR_V_TPG_SS_0_V_TPG_DISPLAY_PORT 0
#define XPAR_V_TPG_SS_0_V_TPG_COLOR_SWEEP 0
#define XPAR_V_TPG_SS_0_V_TPG_ZONE_PLATE 0
#define XPAR_V_TPG_SS_0_V_TPG_FOREGROUND 0


/******************************************************************/

/* Canonical definitions for peripheral V_TPG_SS_0_V_TPG */
#define XPAR_XV_TPG_0_DEVICE_ID XPAR_V_TPG_SS_0_V_TPG_DEVICE_ID
#ifdef XILINX_MCU_EXIST
#define XPAR_XV_TPG_0_S_AXI_CTRL_BASEADDR 0x44A40000
#define XPAR_XV_TPG_0_S_AXI_CTRL_HIGHADDR 0x44A4FFFF
#else
#define XPAR_XV_TPG_0_S_AXI_CTRL_BASEADDR 0x001B0000
#define XPAR_XV_TPG_0_S_AXI_CTRL_HIGHADDR 0x001BFFFF
#endif
#define XPAR_XV_TPG_0_HAS_AXI4S_SLAVE 1
#define XPAR_XV_TPG_0_SAMPLES_PER_CLOCK 2
#define XPAR_XV_TPG_0_NUM_VIDEO_COMPONENTS 3
#define XPAR_XV_TPG_0_MAX_COLS 4096
#define XPAR_XV_TPG_0_MAX_ROWS 2160
#define XPAR_XV_TPG_0_MAX_DATA_WIDTH 8
#define XPAR_XV_TPG_0_SOLID_COLOR 0
#define XPAR_XV_TPG_0_RAMP 0
#define XPAR_XV_TPG_0_COLOR_BAR 1
#define XPAR_XV_TPG_0_DISPLAY_PORT 0
#define XPAR_XV_TPG_0_COLOR_SWEEP 0
#define XPAR_XV_TPG_0_ZONE_PLATE 0
#define XPAR_XV_TPG_0_FOREGROUND 0


/******************************************************************/

/* Definitions for driver VPHY */
#define XPAR_XVPHY_NUM_INSTANCES 1

/* Definitions for peripheral VID_PHY_CONTROLLER */
#define XPAR_VID_PHY_CONTROLLER_DEVICE_ID 0
#ifdef XILINX_MCU_EXIST
#define XPAR_VID_PHY_CONTROLLER_BASEADDR 0x44A20000
#else
#define XPAR_VID_PHY_CONTROLLER_BASEADDR 0x00100000
#endif
#define XPAR_VID_PHY_CONTROLLER_TRANSCEIVER_STR "GTPE2"
#define XPAR_VID_PHY_CONTROLLER_TRANSCEIVER 3
#define XPAR_VID_PHY_CONTROLLER_TX_NO_OF_CHANNELS 3
#define XPAR_VID_PHY_CONTROLLER_RX_NO_OF_CHANNELS 3
#define XPAR_VID_PHY_CONTROLLER_TX_PROTOCOL 3
#define XPAR_VID_PHY_CONTROLLER_RX_PROTOCOL 1
#define XPAR_VID_PHY_CONTROLLER_TX_REFCLK_SEL 1
#define XPAR_VID_PHY_CONTROLLER_RX_REFCLK_SEL 0
#define XPAR_VID_PHY_CONTROLLER_TX_PLL_SELECTION 5  //AVerMedia_Jeff_20190313
#define XPAR_VID_PHY_CONTROLLER_RX_PLL_SELECTION 4  //AVerMedia_Jeff_20190313
#define XPAR_VID_PHY_CONTROLLER_NIDRU 1
#define XPAR_VID_PHY_CONTROLLER_NIDRU_REFCLK_SEL 1
#define XPAR_VID_PHY_CONTROLLER_INPUT_PIXELS_PER_CLOCK 2
#define XPAR_VID_PHY_CONTROLLER_TX_BUFFER_BYPASS 1
#define XPAR_VID_PHY_CONTROLLER_HDMI_FAST_SWITCH 1
#define XPAR_VID_PHY_CONTROLLER_TRANSCEIVER_WIDTH 2
#define XPAR_VID_PHY_CONTROLLER_ERR_IRQ_EN 0
#define XPAR_VID_PHY_CONTROLLER_AXI_LITE_FREQ_HZ 100000000
#define XPAR_VID_PHY_CONTROLLER_DRPCLK_FREQ 100000000
#define XPAR_VID_PHY_CONTROLLER_USE_GT_CH4_HDMI 0


/******************************************************************/

/* Canonical definitions for peripheral VID_PHY_CONTROLLER */
#define XPAR_VPHY_0_DEVICE_ID XPAR_VID_PHY_CONTROLLER_DEVICE_ID
#define XPAR_VPHY_0_BASEADDR XPAR_VID_PHY_CONTROLLER_BASEADDR
#define XPAR_VPHY_0_TRANSCEIVER_STR "GTPE2"
#define XPAR_VPHY_0_TRANSCEIVER 3
#define XPAR_VPHY_0_TX_NO_OF_CHANNELS 3
#define XPAR_VPHY_0_RX_NO_OF_CHANNELS 3
#define XPAR_VPHY_0_TX_PROTOCOL 3
#define XPAR_VPHY_0_RX_PROTOCOL 1
#define XPAR_VPHY_0_TX_REFCLK_SEL 1
#define XPAR_VPHY_0_RX_REFCLK_SEL 0
#define XPAR_VPHY_0_TX_PLL_SELECTION 5
#define XPAR_VPHY_0_RX_PLL_SELECTION 4
#define XPAR_VPHY_0_NIDRU 1
#define XPAR_VPHY_0_NIDRU_REFCLK_SEL 1
#define XPAR_VPHY_0_INPUT_PIXELS_PER_CLOCK 2
#define XPAR_VPHY_0_TX_BUFFER_BYPASS 1
#define XPAR_VPHY_0_HDMI_FAST_SWITCH 1
#define XPAR_VPHY_0_TRANSCEIVER_WIDTH 2
#define XPAR_VPHY_0_ERR_IRQ_EN 0
#define XPAR_VPHY_0_AXI_LITE_FREQ_HZ 100000000
#define XPAR_VPHY_0_DRPCLK_FREQ 100000000
#define XPAR_VPHY_0_USE_GT_CH4_HDMI 0


/******************************************************************/

/* Definitions for driver VTC */
#define XPAR_XVTC_NUM_INSTANCES 1

/* Definitions for peripheral V_HDMI_TX_SS_V_TC */
#define XPAR_V_HDMI_TX_SS_V_TC_DEVICE_ID 0
#define XPAR_V_HDMI_TX_SS_V_TC_BASEADDR 0x00010000
#define XPAR_V_HDMI_TX_SS_V_TC_HIGHADDR 0x0001FFFF
#define XPAR_V_HDMI_TX_SS_V_TC_GENERATE_EN 1
#define XPAR_V_HDMI_TX_SS_V_TC_DETECT_EN 0
#define XPAR_V_HDMI_TX_SS_V_TC_DET_HSYNC_EN 1
#define XPAR_V_HDMI_TX_SS_V_TC_DET_VSYNC_EN 1
#define XPAR_V_HDMI_TX_SS_V_TC_DET_HBLANK_EN 1
#define XPAR_V_HDMI_TX_SS_V_TC_DET_VBLANK_EN 1
#define XPAR_V_HDMI_TX_SS_V_TC_DET_AVIDEO_EN 1
#define XPAR_V_HDMI_TX_SS_V_TC_DET_ACHROMA_EN 0


/******************************************************************/

/* Canonical definitions for peripheral V_HDMI_TX_SS_V_TC */
#define XPAR_VTC_0_DEVICE_ID XPAR_V_HDMI_TX_SS_V_TC_DEVICE_ID
#define XPAR_VTC_0_BASEADDR 0x00010000
#define XPAR_VTC_0_HIGHADDR 0x0001FFFF
#define XPAR_VTC_0_GENERATE_EN 1
#define XPAR_VTC_0_DETECT_EN 0
#define XPAR_VTC_0_DET_HSYNC_EN 1
#define XPAR_VTC_0_DET_VSYNC_EN 1
#define XPAR_VTC_0_DET_HBLANK_EN 1
#define XPAR_VTC_0_DET_VBLANK_EN 1
#define XPAR_VTC_0_DET_AVIDEO_EN 1
#define XPAR_VTC_0_DET_ACHROMA_EN 0


/******************************************************************/

#endif  /* end of protection macro */
