/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   cn312_sdi.h
 * Author: 
 *
 * Created on Jan 25, 2018
 */

#ifndef CN312_SDI_H
#define CN312_SDI_H

#ifdef __cplusplus
extern "C" {
#endif

#define SDI_ID cn312_sdi
#define SDI_DRVNAME I2C_MODEL_MODULE_STR(cn312_sdi)
#define ACTIVE_PATH_NUM 2
#define SDI_STREAM_A 0
#define SDI_STREAM_B 1

enum eDeviceSDI
{
	DEVICE_SDI_0			//1'st XilinxSDI
	//DEVICE_SDI_1,
};

enum eStandardSDI
{
	SDI_SD = 0x01,
	SDI_HD,
	SDI_3GA,
	SDI_3GA_2K,
	SDI_3GA_UNKNOWN,
	SDI_3GB,
	SDI_3GB_2STR,
	SDI_3GB_2K,
	SDI_3GB_UNKNOWN,
	SDI_UNKNOWN = 0xf
};

#if 1
enum eColorModeSDI
{
    VIDEO_YUV_FMT,
    VIDEO_RGB_FULL_FMT,
    VIDEO_RGB_LIMIT_FMT,
};

enum ePixelModeSDI
{
	SINGLE_PIXEL_MODE,
	DUAL_PIXEL_MODE,
};

enum eVideoTypeSDI
{
    VIDEO_RGB_MODE,
    VIDEO_422_MODE,
    VIDEO_444_MODE,
    VIDEO_420_MODE,
};
#endif

enum eColorFormatSDI
{
	YCbCr_422_10 = 0,
	YCbCr_444_10,
	RGB_444_10,
	YCbCrA_4444_10,
	RGBA_4444_10,
	YCbCr_422_12,
	YCbCr_444_12,
	RGB_444_12,
	XYZ_444_12
};

enum eFrameRateSDI
{
	SDI_FPS_NONE = 0,
	SDI_FPS_2398 = 2,
	SDI_FPS_2400,
	SDI_FPS_4795,
	SDI_FPS_2500,
	SDI_FPS_2997,
	SDI_FPS_3000,
	SDI_FPS_4800,
	SDI_FPS_5000,
	SDI_FPS_5994,
	SDI_FPS_6000
};

enum eRGBtoYUVSDI
{
	y_g_coef = 0,
	y_b_coef,
	y_r_coef,
	y_offset,
	cb_g_coef,
	cb_b_coef,
	cb_r_coef,
	cb_offset,
	cr_g_coef,
	cr_b_coef,
	cr_r_coef,
	cr_offset,

	y_g_coef_s,
	y_b_coef_s,
	y_r_coef_s,
	y_offset_s,
	cb_g_coef_s,
	cb_b_coef_s,
	cb_r_coef_s,
	cb_offset_s,
	cr_g_coef_s,
	cr_b_coef_s,
	cr_r_coef_s,
	cr_offset_s
};

enum eYUVtoRGBSDI
{
	g_y_coef = 0,
	g_cb_coef,
	g_cr_coef,
	y1_offset,
	b_y_coef,
	b_cb_coef,
	b_cr_coef,
	cb1_offset,
	r_y_coef,
	r_cb_coef,
	r_cr_coef,
	cr1_offset,

	g_y_coef_s,
	g_cb_coef_s,
	g_cr_coef_s,
	y1_offset_s,
	b_y_coef_s,
	b_cb_coef_s,
	b_cr_coef_s,
	cb1_offset_s,
	r_y_coef_s,
	r_cb_coef_s,
	r_cr_coef_s,
	cr1_offset_s,

	y2_offset,
	cb2_offset,
	cr2_offset,
	y2_offset_s,
	cb2_offset_s,
	cr2_offset_s
};

static const int RGBtoYUV_TABLE[24][4] =
{
	//				RGBF_to_BT709		RGBL_to_BT709		RGBF_to_BT601		RGBL_to_BT601
	/*y_g_coef*/	{ 10063,			11718,				8259,				9617},
	/*y_b_coef*/	{ 1016,				1183,				1604,				1868},
	/*y_r_coef*/	{ 2992,				3483,				4207,				4899},
	/*y_offset*/	{ 256,				0,					256,				0},
	/*cb_g_coef*/	{ 5548,				6459,				4768,				5551},
	/*cb_b_coef*/	{ 7196,				8379,				7196,				8379},
	/*cb_r_coef*/	{ 1648,				1920,				2428,				2828},
	/*cb_offset*/	{ 2048,				2048,				2048,				2048},
	/*cr_g_coef*/	{ 6536,				7610,				6024,				7016},
	/*cr_b_coef*/	{ 660,				768,				1171,				1363},
	/*cr_r_coef*/	{ 7196,				8379,				7196,				8379},
	/*cr_offset*/	{ 2048,				2048,				2048,				2048},

	/*y_g_coef_s*/	{ 0,				0,					0,					0},
	/*y_b_coef_s*/	{ 0,				0,					0,					0},
	/*y_r_coef_s*/	{ 0,				0,					0,					0},
	/*y_offset_s*/	{ 0,				0,					0,					0},
	/*cb_g_coef_s*/	{ 1,				1,					1,					1},
	/*cb_b_coef_s*/	{ 0,				0,					0,					0},
	/*cb_r_coef_s*/	{ 1,				1,					1,					1},
	/*cb_offset_s*/	{ 0,				0,					0,					0},
	/*cr_g_coef_s*/	{ 1,				1,					1,					1},
	/*cr_b_coef_s*/	{ 1,				1,					1,					1},
	/*cr_r_coef_s*/	{ 0,				0,					0,					0},
	/*cr_offset_s*/	{ 0,				0,					0,					0},
};

static const int YUVtoRGB_TABLE[30][6] =
{
	//	BT709_to_RGBF		BT709_to_RGBL		BT601_to_RGBF		BT601_to_RGBL		BT601_to_BT709		BT709_to_BT601
/*g_y_coef*/	{ 19078,		16384,			19078,			16384,			16384,			16384,},
/*g_cb_coef*/	{ 3495,			3000,			6418,			5512,			1892,			1629,},
/*g_cr_coef*/	{ 8731,			7499,			13320,			11439,			3406,			3141,},
/*y1_offset*/	{ 0,			0,			0,			0,			0,			0,},
/*b_y_coef*/	{ 19078,		16384,			19078,			16384,			0,			0,},
/*b_cb_coef*/	{ 34611,		29724,			33051,			28385,			16689,			16219,},
/*b_cr_coef*/	{ 0,			0,			0,			0,			1878,			1812,},
/*cb1_offset*/	{ 0,			0,			0,			0,			0,			0,},
/*r_y_coef*/	{ 19078,		16384,			19078,			16384,			0,			0,},
/*r_cb_coef*/	{ 0,			0,			0,			0,			1229,			1189,},
/*r_cr_coef*/	{ 29373,		25226,			26149,			22458,			16799,			16112,},
/*cr1_offset*/	{ 19078,		0,			0,			0,			0,			0,},

/*g_y_coef_s*/	{ 0,			0,			0,			0,			0,			0,},
/*g_cb_coef_s*/	{ 1,			1,			1,			1,			1,			0,},
/*g_cr_coef_s*/	{ 1,			1,			1,			1,			1,			0,},
/*y1_offset_s*/	{ 1,			1,			1,			1,			0,			0,},
/*b_y_coef_s*/	{ 0,			0,			0,			0,			0,			0,},
/*b_cb_coef_s*/	{ 0,			0,			0,			0,			0,			0,},
/*b_cr_coef_s*/	{ 0,			0,			0,			0,			0,			1,},
/*cb1_offset_s*/{ 1,			1,			1,			1,			1,			1,},
/*r_y_coef_s*/	{ 0,			0,			0,			0,			0,			0,},
/*r_cb_coef_s*/	{ 0,			0,			0,			0,			0,			1,},
/*r_cr_coef_s*/	{ 0,			0,			0,			0,			0,			0,},
/*cr1_offset_s*/{ 1,			1,			1,			1,			1,			1,},

/*y2_offset*/	{ 1230,			1312,			2169,			2118,			662,			596,},
/*cb2_offset*/	{ 4624,			3715,			4429,			3548,			272,			247,},
/*cr2_offset*/	{ 3969,			3153,			3566,			2807,			205,			182,},
/*y2_offset_s*/	{ 0,			0,			0,			0,			0,			1,},
/*cb2_offset_s*/{ 1,			1,			1,			1,			1,			0,},
/*cr2_offset_s*/{ 1,			1,			1,			1,			1,			0,},
};

/////////////////////////////////////
#define PROGRESS  0
#define INTERLACE 1

#define Vneg      0
#define Hneg      0
#define Vpos      1
#define Hpos      1

//Add audio output sample bits function.
#define SDI_AUD_24_BITS	0x00
#define SDI_AUD_20_BITS	0x01
#define SDI_AUD_16_BITS	0x02
#define SDI_AUD_DEF_BITS	0x02

enum
{
    IT601_LIMIT_RANGE  = 0,
    IT601_FULL_RANGE   = 1,
    IT709_LIMIT_RANGE  = 2,
    IT709_FULL_RANGE   = 3
};

typedef enum SDI_VidFrm_ScnMod_e
{
    SDI_INTSCAN,
    SDI_PRGSCAN
} SDI_VidFrm_ScnMod_t;

typedef enum SDI_VidFrm_Pol_e
{
    eSDI_VidFrm_Pol_High,
    eSDI_VidFrm_Pol_Low
} SDI_VidFrm_Pol_t;

typedef enum eSDIHWInitFormat_e
{
    SDI_HW_INIT_480I = 0,
    SDI_HW_INIT_576I ,
    SDI_HW_INIT_720P_2398,
    SDI_HW_INIT_720P_2400,
    SDI_HW_INIT_720P_2500,
    SDI_HW_INIT_720P_2997,
    SDI_HW_INIT_720P_3000,
    SDI_HW_INIT_720P_5000,
    SDI_HW_INIT_720P_5994,
    SDI_HW_INIT_720P_6000,
    SDI_HW_INIT_1080I_5000,
    SDI_HW_INIT_1080I_6000,
    SDI_HW_INIT_1080PsF_2398,
    SDI_HW_INIT_1080PsF_2400,
    SDI_HW_INIT_1080PsF_2500,
    SDI_HW_INIT_1080PsF_2997,
    SDI_HW_INIT_1080PsF_3000,
    SDI_HW_INIT_1080P_2398,
    SDI_HW_INIT_1080P_2400,
    SDI_HW_INIT_1080P_2500,
    SDI_HW_INIT_1080P_2997,
    SDI_HW_INIT_1080P_3000,
    SDI_HW_INIT_MAX
}eSDIHWInitFormat_t;

//[Willy_010_20150525]Add SDI color conversion function.
typedef enum SDI_eResolutionType
{
	SDI_RES_SD = 0,
	SDI_RES_HD = 1,
}SDI_eResolutionType_t;

enum SDI_eOutputAudioChannel
{
    SDI_OUTPUT_AUDIO_CHANNEL_1 = 0,
    SDI_OUTPUT_AUDIO_CHANNEL_2,
    SDI_OUTPUT_AUDIO_CHANNEL_3,
    SDI_OUTPUT_AUDIO_CHANNEL_4,
    SDI_OUTPUT_AUDIO_CHANNEL_5,
    SDI_OUTPUT_AUDIO_CHANNEL_6,
    SDI_OUTPUT_AUDIO_CHANNEL_7,
    SDI_OUTPUT_AUDIO_CHANNEL_8,
    MAX_SDI_OUTPUT_AUDIO_CHANNEL_COUNT,
};

enum SDI_eAssignedAudioGroup
{
    SDI_PRIMARY_AUDIO_GROUP = 0,
    SDI_SECONDARY_AUDIO_GROUP,
    MAX_SDI_AUDIO_GROUP,
};

// 7601 working mode, 
//  0 - 7601 working on SD video format
//  1 - 7601 working on HD video format
typedef enum //eConfigADV7601
{
    SDI_SD_MODE,
    SDI_HD_MODE,
}sdi_out_format_e;


typedef struct SDI_VidFrm_Dir_s
{
    U32_T     TOT;
    U32_T     AW;
    U32_T     FP;
    U32_T     SW;
    U32_T     Pol;
} SDI_VidFrm_Dir_t;

typedef struct SDI_VidFrm_Format_s
{
    SDI_VidFrm_Dir_t     Hor;
    SDI_VidFrm_Dir_t     Ver;
    SDI_VidFrm_ScnMod_t  ScnMod;
    U32_T  wFrmFrq;
    eSDIHWInitFormat_t     FormatNum;
} SDI_VidFrm_Format_t;

//[Willy_018_20150610]Add the cea861 id condition.
typedef struct{
    U8_T   Id4x3;
    U8_T   Id16x9;
}CEA_ID;

typedef struct
{
     // IT6604 reference 
     U32_T        HActive ;       // horizontal total line
     U32_T        VActive ;       // vertical total line    
     U32_T        HTotal ;        // horizontal active line
     U32_T        VTotal ;        // vertical active line 
     //LONG        PCLK ;
     U32_T        PCLK ;
     //U8_T        xCnt ;
     U32_T        xCnt ;
     U8_T        ScanMode ;
     U8_T        VPolarity ;
     U8_T        HPolarity ;

     // self defined
     U32_T        Rate ;          // frame rate
     U32_T  QP_InCtrl ;     // [Ian_022] : add the control setting
     U32_T  QP_InRes  ;     // [Ian_022] : add the resolution setting
     U32_T  QP_InSync ;     // [Ian_022] : add the sync setting 
     
     //U8_T forced ;             // [Ian_022] : comment // [Ian_018] : 0 = disable, 
                                 //                        1 = enable forced 50/60p encode
} video_timing_t ;

typedef struct HDMI_CEA861ID
{
	CEA_ID Cea861Id;
	video_timing_t VidInfo;
} HDMI_CEA861ID;

typedef struct _SDI_AUDIO_SOURCE_SELECTOR
{
    U8_T GroupSel;//0 or 1
    U8_T ChNum;   //0 ~ 3
} SDI_AUDIO_SOURCE_SELECTOR;

typedef struct _SDI_AUDIO_CROSSPOINT
{
    U8_T PrimaryGroup;
    U8_T SecodaryGroup;
    SDI_AUDIO_SOURCE_SELECTOR OutChSrc[MAX_SDI_OUTPUT_AUDIO_CHANNEL_COUNT];
} SDI_AUDIO_CROSSPOINT;

/////////////////////////////////////

typedef enum  {
    SDI_OP_CH_SEL_GBR_YUV = 0,
    SDI_OP_CH_SEL_GRB_YVU = 1,
    SDI_OP_CH_SEL_BGR_UYV = 2,
    SDI_OP_CH_SEL_RGB_VYU = 3,
    SDI_OP_CH_SEL_BRG_UVY = 4,
    SDI_OP_CH_SEL_RBG_VUY = 5,
}sdi_out_ch_order_e;

typedef enum 
{
    SDI_OUT_YUV601,
    SDI_OUT_YUV709,
    SDI_OUT_RGB_LIMITED,
    SDI_OUT_RGB_FULL,
}sdi_out_colorspace_e;

typedef struct
{
    int device_index;
    sdi_out_colorspace_e out_colorspace;
}sdi_out_ctrl_t;

typedef enum
{
    SDI_LOCK,
    SDI_UNLOCK,        
    //SDI_HDCP,        
}sdi_event_e;

typedef void (*sdi_callback_t)(void *cxt,sdi_event_e event);

typedef enum
{
    SDI_CS_YUV,
    SDI_CS_RGB_FULL,
    SDI_CS_RGB_LIMIT,
}sdi_colorspace_e;

typedef struct
{
    int width;
    int height;
    BOOL_T is_interlace;
    int framerate;
    int denominator;
    U32_T pixel_clock;
    sdi_out_colorspace_e colorspace;
    int hbackporch;
    int vbackporch;
    int htotal;
    int vtotal;
	
}sdi_frameinfo_t;

enum sdi_audio_sample {
	SDI_AUDIO_RATE_32000, //0
	SDI_AUDIO_RATE_44100, //1
	SDI_AUDIO_RATE_48000, //2
	SDI_AUDIO_RATE_88200,
	SDI_AUDIO_RATE_96000,
	SDI_AUDIO_RATE_176400,
	SDI_AUDIO_RATE_192000,
};

typedef struct
{
	U8_T m_WorkingMode;
	U8_T m_ColorSpaceMode;
	U8_T m_SamplingMode;
	U8_T m_PixelMode;
	U32_T m_PacketRepetition;
	U32_T m_PacketVideoLock;
	U32_T m_PacketWidth;
	U32_T m_PacketHeight;
	U32_T m_PacketInterlace;
	U32_T m_PacketFrameRate;
	U32_T m_RxFrameRate;

	U8_T m_Old_WorkingMode;
	U8_T m_Old_ColorSpaceMode;
	U8_T m_Old_SamplingMode;
	U8_T m_Old_PixelMode;
	U32_T m_Old_PacketRepetition;
	U32_T m_Old_PacketVideoLock;
	U32_T m_Old_PacketWidth;
	U32_T m_Old_PacketHeight;
	U32_T m_Old_PacketInterlace;
	U32_T m_Old_PacketFrameRate;
	U32_T m_Old_RxFrameRate;
	
	U8_T m_WorkingMode_in;
	U8_T m_WorkingMode_out;
	U32_T m_CSFourCC_out;
	U8_T m_PixelFmt_out;
	U8_T m_ColorSpaceMode_in; // VIDEO_YUV_FMT // VIDEO_RGB_FULL_FMT // VIDEO_RGB_LIMIT_FMT
}sdi_packetinfo_t;

void sdi_get_frameinfo(handle_t sdi_handle,sdi_frameinfo_t *frameinfo);
//void sdi_yuv2rgb_coeff(handle_t sdi_handle,int ch, int coeff_mode);
//void sdi_rgb2yuv_coeff(handle_t sdi_handle,int ch, int coeff_mode);
void sdi_get_packetinfo(handle_t sdi_handle,sdi_packetinfo_t *sdi_packetinfo);
void sdi_set_color_space(handle_t sdi_handle,sdi_packetinfo_t *sdi_packetinfo);

void sdi_add_trace(handle_t sdi_handle,void *trace_handle);    
void sdi_set_out_format(handle_t sdi_handle,sdi_out_format_e format);
void sdi_set_audio_out_enable(handle_t sdi_handle,BOOL_T Enable,int ch);
void sdi_register_callback(handle_t sdi_handle, sdi_callback_t callback_func, void *cxt);
void sdi_unregister_callback(handle_t sdi_handle);
void sdi_set_stream(handle_t sdi_handle, U32_T input);

void sdi_power_off(handle_t sdi_handle);
void sdi_power_on(handle_t sdi_handle);

///////////////////////////


#ifdef __cplusplus
}
#endif

#endif /* CN312_SDI_H */

