/*===================================================================
 * Copyright(c) AVerMedia TECHNOLOGIES, Inc. 2017
 * All rights reserved
 * =================================================================
 * adv7619.h
 *
 *  Created on: Apr 15, 2017
 *      Author: 
 *      Version:
 * =================================================================
 */
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

#ifndef ADV7619_H
#define ADV7619_H

#ifdef __cplusplus
extern "C" {
#endif


#define ADV7619_ID adv7619
#define ADV7619_DRVNAME I2C_MODEL_MODULE_STR(adv7619)
#define INFOFRAME_MAXSIZE 30   
    
typedef enum
{
    XTAL_FREQ_28_63636MHz,
    XTAL_FREQ_27MHz,
    XTAL_FREQ_24_576MHz,        
    XTAL_FREQ_24MHz,
}adv7619_xtal_freq_e;

typedef enum
{
    ADV7619_OUT_FORMAT_SDR_ITU656_8 = 0x00,
    ADV7619_OUT_FORMAT_SDR_ITU656_10 = 0x01,
    ADV7619_OUT_FORMAT_SDR_ITU656_12_MODE0 = 0x02,
    ADV7619_OUT_FORMAT_SDR_ITU656_12_MODE1 = 0x06,
    ADV7619_OUT_FORMAT_SDR_ITU656_12_MODE2 = 0x0a,
    ADV7619_OUT_FORMAT_DDR_422_8 = 0x20,
    ADV7619_OUT_FORMAT_DDR_422_10 = 0x21,
    ADV7619_OUT_FORMAT_DDR_422_12_MODE0 = 0x22,
    ADV7619_OUT_FORMAT_DDR_422_12_MODE1 = 0x23,
    ADV7619_OUT_FORMAT_DDR_422_12_MODE2 = 0x24,
    ADV7619_OUT_FORMAT_SDR_444_24 = 0x40,
    ADV7619_OUT_FORMAT_SDR_444_30 = 0x41,
    ADV7619_OUT_FORMAT_SDR_444_36_MODE0 = 0x42,
    ADV7619_OUT_FORMAT_SDR_444_36_MODE1 = 0x46,
    ADV7619_OUT_FORMAT_SDR_444_24_MODE3 = 0x4C,
    ADV7619_OUT_FORMAT_SDR_444_24_MODE4 = 0x50,
    ADV7619_OUT_FORMAT_SDR_444_30_MODE4 = 0x51,
    ADV7619_OUT_FORMAT_SDR_444_36_MODE4 = 0x52,
    ADV7619_OUT_FORMAT_SDR_444_2X24_INTERLEAVE_MODE0 = 0x54,            
    ADV7619_OUT_FORMAT_DDR_444_24 = 0x60,
    ADV7619_OUT_FORMAT_DDR_444_30 = 0x61,
    ADV7619_OUT_FORMAT_DDR_444_36 = 0x62,
    ADV7619_OUT_FORMAT_SDR_ITU656_16 = 0x80,
    ADV7619_OUT_FORMAT_SDR_ITU656_20 = 0x81,
    ADV7619_OUT_FORMAT_SDR_ITU656_24_MODE0 = 0x82,
    ADV7619_OUT_FORMAT_SDR_ITU656_24_MODE1 = 0x86,
    ADV7619_OUT_FORMAT_SDR_ITU656_24_MODE2 = 0x8a,
    ADV7619_OUT_FORMAT_SDR_422_20_MODE3    =0x8d,
    ADV7619_OUT_FORMAT_SDR_422_16_MODE4    =0x90,
    ADV7619_OUT_FORMAT_SDR_422_20_MODE4    =0x91,
    ADV7619_OUT_FORMAT_SDR_422_24_MODE4    =0x92,
    ADV7619_OUT_FORMAT_SDR_422_2X16_INTERLEAVE_MODE0 = 0x94,                    
    ADV7619_OUT_FORMAT_SDR_422_2X20_INTERLEAVE_MODE0 = 0x95,        
    ADV7619_OUT_FORMAT_SDR_422_2X24_INTERLEAVE_MODE0 = 0x96,        
    ADV7619_OUT_FORMAT_PAR_8_MODE0=0xc0,
    ADV7619_OUT_FORMAT_PAR_10_MODE0=0xc1,
    ADV7619_OUT_FORMAT_PAR_12_MODE0=0xc2,
    
}adv7619_out_format_e;

typedef enum  {
    ADV7619_OP_CH_SEL_GBR_YUV = 0,
    ADV7619_OP_CH_SEL_GRB_YVU = 1,
    ADV7619_OP_CH_SEL_BGR_UYV = 2,
    ADV7619_OP_CH_SEL_RGB_VYU = 3,
    ADV7619_OP_CH_SEL_BRG_UVY = 4,
    ADV7619_OP_CH_SEL_RBG_VUY = 5,
}adv7619_out_ch_order_e;

typedef enum 
{
    ADV7619_OUT_DEFAULT,
    ADV7619_OUT_YUV601,
    ADV7619_OUT_YUV709,
    ADV7619_OUT_RGB_LIMITED,
    ADV7619_OUT_RGB_FULL,
}adv7619_out_colorspace_e;



typedef struct
{
    adv7619_out_format_e out_fmt;
    adv7619_out_ch_order_e out_ch_order;
    adv7619_out_colorspace_e out_colorspace;
    
    unsigned blank_data:1;  // 0: no blank data 1: blank data
    unsigned insert_av_codes:1; // 0:No AV codes 1:AV codes 
    unsigned invert_cbcr:1; // 0: follow out_format 1: swap cb,cr
    unsigned output_bus_lsb_to_msb:1; // 0: MSB to LSB 1: LSB to MSB

}adv7619_out_ctrl_t;


typedef struct
{
    U8_T cp_map_addr;
    U8_T hdmi_map_addr;
    U8_T repeater_map_addr;
    U8_T edid_map_addr;
    U8_T infoframe_map_addr;
    U8_T cec_map_addr;
    U8_T dpll_map_addr;
    
    adv7619_xtal_freq_e xtal_freq;
    adv7619_out_ctrl_t out_ctrl;
    
}adv7619_cfg_t;

typedef enum
{
    ADV7619_LOCK,
    ADV7619_UNLOCK,
    ADV7619_UNLOCK_ENHANCE,  
    ADV7619_HDCP,
    ADV7619_FRAME_CHANGE,  
    //ADV7619_LOSS,         
    ADV7619_HOTPLUG,
}adv7619_event_e;

typedef void (*adv7619_callback_t)(void *cxt,adv7619_event_e event);
typedef void (*adv7619_callback_t_for_get_cardid)(void *cxt, U32_T* cardid);

void adv7619_add_trace(handle_t adv7619_handle,void *trace_handle);    
void adv7619_set_out_format(handle_t adv7619_handle,adv7619_out_format_e format);
void adv7619_register_callback(handle_t adv7619_handle,adv7619_callback_t callback_func,void *cxt);
void adv7619_register_callback_for_getcardid(handle_t adv7619_handle, adv7619_callback_t_for_get_cardid callback_func, void* cb_cxt_for_getid);


#define CM311H_ID cm311h
#define CM311H_DRVNAME I2C_MODEL_MODULE_STR(cm311h)

enum    
{
    RXLINK0,
    RXLINK1,
    TXLINK0,
    TXLINK1,
    SLAVE_ADDR_COUNT,
};    
typedef enum
{
    HOTPLUG_LOW,
    HOTPLUG_HIGH,        
}hotplug_pin_e;
typedef void (*hotplug_ctrl_func_t)(void *,hotplug_pin_e);
typedef void (*hw_reset_func_t)(void *);

typedef struct
{
    U8_T slave_addr_cfg[SLAVE_ADDR_COUNT];
    hotplug_ctrl_func_t  hotplug_ctrl_func;
    hw_reset_func_t      hw_reset_func;
}cm311h_cfg_t;


typedef enum
{
    CS_YUV,
    CS_RGB_FULL,
    CS_RGB_LIMIT,
}adv7619_colorspace_e;

typedef struct
{
    int brightness;
    int contrast;
    int saturation;
    int hue;
    //adv7619_colorspace_e colorspace;
}adv7619_bchs_t;

typedef enum
{
    ADV7619_BCHS_BRIGHTNESS,
    ADV7619_BCHS_CONTRAST,
    ADV7619_BCHS_HUE,        
    ADV7619_BCHS_SATURATION,
}adv7619_bchs_e;

typedef struct
{
    unsigned width;
    unsigned height;
    BOOL_T is_interlace;
    unsigned framerate;
    unsigned denominator;
    U32_T    pixel_clock;
    adv7619_colorspace_e packet_colorspace;
    int dual_pixel;
    int sampling_mode;
    int dual_pixel_like;
    //int packet_colorspace;
    unsigned int adv7619_hdcp_flag;
    int is_ITU601;
    int is_ITU709;
    int is_yuv422;
    int is_yuv444;
}adv7619_frameinfo_t;

enum adv7619_audio_sample {
	ADV7619_AUDIO_RATE_32000, //0
	ADV7619_AUDIO_RATE_44100, //1
	ADV7619_AUDIO_RATE_48000, //2
	ADV7619_AUDIO_RATE_88200,
	ADV7619_AUDIO_RATE_96000,
	ADV7619_AUDIO_RATE_176400,
	ADV7619_AUDIO_RATE_192000,
};

void adv7619_get_frameinfo(handle_t adv7619_handle,adv7619_frameinfo_t *frameinfo);
void adv7619_get_audiorate(handle_t adv7619_handle,enum adv7619_audio_sample *audioinfo);

void adv7619_get_yuvmode(handle_t adv7619_handle,int *yuv422);

//void adv7619_set_out_bchs(handle_t adv7619_handle,adv7619_bchs_t *BCHSinfo,adv7619_bchs_e bchs);
//void adv7619_get_out_bchs(handle_t adv7619_handle,adv7619_bchs_t *BCHSinfo,adv7619_bchs_e bchs);
void adv7619_set_freerun_screen(handle_t adv7619_handle,BOOL_T is_blue_screen);

void adv7619_set_bchs(handle_t adv7619_handle,int *BCHSinfo,int *bchs_select);
//void adv7619_get_bchs(handle_t adv7619_handle,int *BCHSinfo,int *bchs_select);
void adv7619_get_brightness(handle_t adv7619_handle,int *BCHSinfo);
void adv7619_get_contrast(handle_t adv7619_handle,int *BCHSinfo);
void adv7619_get_hue(handle_t adv7619_handle,int *BCHSinfo);
void adv7619_get_saturation(handle_t adv7619_handle,int *BCHSinfo);

//void adv7619_get_board_id(handle_t adv7619_handle,int *board_id);

void adv7619_get_aviinfoframe(handle_t adv7619_handle,U8_T *aviinfo);
void adv7619_get_vendorinfoframe(handle_t adv7619_handle,U8_T *aviinfo);
void adv7619_get_audioinfoframe(handle_t adv7619_handle,U8_T *aviinfo);

//void adv7619_get_hdcp_flag(handle_t adv7619_handle,adv7619_frameinfo_t *frameinfo);

int  adv7619_get_video_time_list(handle_t adv7619_handle, U8_T* val, int* size);
int adv7619_set_video_time_list(handle_t cxt, U8_T* val, int size);

void adv7619_power_off(handle_t adv7619_handle);
void adv7619_power_on(handle_t adv7619_handle);

#ifdef __cplusplus
}
#endif

#endif /* ADV7619_H */

