/*===================================================================
 * Copyright(c) AVerMedia TECHNOLOGIES, Inc. 2017
 * All rights reserved
 * =================================================================
 * framegrabber_priv.h
 *
 *  Created on: Apr 15, 2017
 *      Author: 
 *      Version:
 * =================================================================
 */
 
#ifndef MODULE_V4L2_FRAMEGRABBER_PRIV_H_
#define MODULE_V4L2_FRAMEGRABBER_PRIV_H_

#define FRAMEGRABBER_MAX_INPUT_NUM 8

#define FRAMEGRABBER_MAX_AVISIZE 30 //same as adv7619

typedef struct
{
	BASIC_CXT_HANDLE_DECLARE;
	const char *name;
	framegrabber_framesize_mask_e framesize_cap;
	framegrabber_refreshrate_e framesize_info[FRAMEGRABBER_SUPPORT_FRAMESIZE_NUM];
} framegrabber_input_info_t;

typedef struct
{
	int input_no;
	framegrabber_input_info_t input_info[FRAMEGRABBER_MAX_INPUT_NUM];
	framegrabber_property_t property;
	int current_input;
	framegrabber_hdcp_status_e current_hdcp_status;
	framegrabber_input_status_e current_input_status;
	framegrabber_status_bitmask_e current_status;
	framegrabber_pixfmt_bitmask_e pixfmt_cap;
	framegrabber_frame_size_t current_out_framesize;
	framegrabber_frame_size_t current_input_framesize;
	framegrabber_rect_t current_crop_rect;
	framegrabber_hdcp_version_bitmask_e input_hdcp_version;
	framegrabber_hdcp_version_bitmask_e user_hdcp_version;
	framegrabber_framemode_e framemode;
	enum framegrabber_audio_sample current_audiorate;
	int current_framerate;
	int current_out_framerate;
	int current_denominator;
	int current_out_pixfmt;
	int current_bchs_value;
	int current_bchs_selection;
	BOOL_T current_input_interlace;
	unsigned max_supported_width;
	unsigned max_frame_size;
	//struct v4l2_device *v4l2_dev;
	void *data;
	int current_dual_pixel;
	int current_fpga_bypassmode;
	int current_output_pixelformat;

	framegrabber_interface_t interface;
    unsigned int hdcp_flag;
    int card_id;
    int ITU_flag;
    
    U8_T current_aviinfoframe[FRAMEGRABBER_MAX_AVISIZE];
    U8_T current_vendorinfoframe[FRAMEGRABBER_MAX_AVISIZE];
    U8_T current_audioinfoframe[FRAMEGRABBER_MAX_AVISIZE];

    int current_flash_accessblock;
    int current_rx_update;
    int current_flash_pmpid;
	int current_flash_version;
	int current_flash_result;
	
#if defined (AVER_CARD_CN312S)
    int buffer_info;
    int line_num;
    int block_num;
    int last_blocksize;
#elif defined (AVER_CARD_CM311H)
	void* edid_buf;
	int fault_tolerant_min;
	int fault_tolerant_max;
	U8_T last_edid_status;
	U8_T is_run_edid;
    #endif
	framegrabber_macrovision_status_e current_macrovision_status;
}framegrabber_context_t;

#endif // MODULE_V4L2_FRAMEGRABBER_PRIV_H_

