/*===================================================================
 * Copyright(c) AVerMedia TECHNOLOGIES, Inc. 2017
 * All rights reserved
 * =================================================================
 * v4l2_model_device.h
 *
 *  Created on: Apr 15, 2017
 *      Author: 
 *      Version:
 * =================================================================
 */
 

#ifndef V4L2_MODEL_DEVICE_H_
#define V4L2_MODEL_DEVICE_H_
#include "framegrabber.h"
#include "pic_bmp.h"

#define MAX_EDID_DATA		1024
#define AVAILABLE_EDID_LIST_MAX	50


typedef struct custom_edid			
{
	U16_T width;
    U16_T height;
    U8_T interlaced;
    U8_T   framerate;
    U8_T   framerate_decimal;
}custom_edid_t;

typedef struct v4l2_custom_edid
{
	custom_edid_t edid_val[AVAILABLE_EDID_LIST_MAX];
	int nEdidSize;
}v4l2_custom_edid_t;

typedef struct frame_info
{
	int width;
	int height;
	int interlace;
	int framerate;
}frame_info_t;

typedef struct edid_buf
{
	unsigned char ucStatus;		//means card edid status now	

	frame_info_t input_frame_info;

	custom_edid_t edid_data[AVAILABLE_EDID_LIST_MAX];
	int edid_data_size;
}edid_buf_t;

typedef struct edid_ft_val
{
	int fault_tolerant_min;
	int fault_tolerant_max;
}edid_ft_val_t;

#if 1
struct v4l2_dump_flash {
	__u32 pad;
	__u32 start_block;
	__u32 blocks;
	__u32 reserved[5];
	__u8  *flash;
};
#endif

typedef struct
{
	v4l2_model_callback_t callback;
	v4l2_model_callback_parameter_t data;
}v4l2_model_callback_item_t;

typedef struct 
{
	struct list_head list;
	v4l2_model_ioctl_hook_func_t ioctl_hook_func;
	void *data;
}v4l2_model_ioctl_hook_item_t;

typedef struct
{
	v4l2_model_buffer_info_t *vbuf_info;
	//unsigned lines;
	unsigned int rcv_size;

}framebuffer_info_t;

typedef struct v4l2_model_context_s
{
    

	struct v4l2_device v4l2_dev;
	struct video_device vdev;
	struct vb2_queue queue;
	struct mutex lock;
    struct device *dev;

	void  *vb2_context;
	v4l2_model_device_setup_t device_info;
	v4l2_model_callback_item_t callbacks[V4L2_MODEL_CALLBACK_NUM];

	struct list_head ioctl_hook_list[HOOK_IOCTL_TYPE_NUM];
	framegrabber_handle_t framegrabber_handle;
	framebuffer_info_t current_framebuf_info;
	int inibuffer_create;
	int inibuffer_index;
	//int vb_address[32];
	//v4l2_model_vb2_buffer_t *linebuf;
	pic_bmp_handle_t pic_bmp_handle;
}v4l2_model_context_t;

 

#define V4L2_MODEL_DEBUG(fmt, ...) //printk(fmt, ##__VA_ARGS__)


#endif /* V4L2_MODEL_DEVICE_H_ */
