/*===================================================================
 * Copyright(c) AVerMedia TECHNOLOGIES, Inc. 2017
 * All rights reserved
 * =================================================================
 * v4l2_model_ioctl.h
 *
 *  Created on: Apr 15, 2017
 *      Author: 
 *      Version:
 * =================================================================
 */
 

#ifndef V4L2_MODEL_IOCTL_H_
#define V4L2_MODEL_IOCTL_H_

#include <linux/videodev2.h>
//#include <uapi/linux/videodev2.h>
#include "typedef.h"
#include "v4l2_model_device.h"


int v4l2_model_ioctl_querycap(struct file *file, void *fh, struct v4l2_capability *cap);
int v4l2_model_ioctl_enum_fmt_vid_cap(struct file *file, void *fh, struct v4l2_fmtdesc *f);
int v4l2_model_ioctl_g_fmt_vid_cap(struct file *file, void *fh, struct v4l2_format *f);
int v4l2_model_ioctl_s_fmt_vid_cap(struct file *file, void *fh, struct v4l2_format *f);
int v4l2_model_ioctl_try_fmt_vid_cap(struct file *file, void *fh, struct v4l2_format *f);
int v4l2_model_ioctl_enum_framesizes(struct file *file, void *fh, struct v4l2_frmsizeenum *fsize);
int v4l2_model_ioctl_enum_input(struct file *file, void *fh, struct v4l2_input *inp);
int v4l2_model_ioctl_g_input(struct file *file, void *fh, unsigned int *i);
int v4l2_model_ioctl_s_input(struct file *file, void *fh, unsigned int i);
int v4l2_model_ioctl_enum_frameintervals(struct file *file, void *fh,struct v4l2_frmivalenum *fival);
int v4l2_model_ioctl_g_parm(struct file *file, void *fh,struct v4l2_streamparm *a);
int v4l2_model_ioctl_s_parm(struct file *file, void *fh,struct v4l2_streamparm *a);
int v4l2_model_ioctl_queryctrl(struct file *file, void *fh,struct v4l2_queryctrl *a);
int v4l2_model_ioctl_g_ctrl(struct file *file, void *fh,struct v4l2_control *a);
int v4l2_model_ioctl_s_ctrl(struct file *file, void *fh,struct v4l2_control *a);
int v4l2_model_ioctl_s_customedid(struct file *file, struct v4l2_custom_edid* custom_edid);
int v4l2_model_ioctl_g_customedid(struct file *file, struct edid_buf* edid_buf_info);
int v4l2_model_ioctl_s_edid_ft_val(struct file *file, struct edid_ft_val* ft_val);

int v4l2_model_ioctl_cropcap(struct file *file, void *fh,struct v4l2_cropcap *a);
int v4l2_model_ioctl_g_flash_result(struct file *file, int *result);
int v4l2_model_ioctl_g_flash_pmpid(struct file *file, int *pmpid);
int v4l2_model_ioctl_g_flash_version(struct file *file, int *version);
int v4l2_model_ioctl_s_flash_accessblock(struct file *file, int *accessblock);
#if defined (AVER_CARD_CN312M)
int v4l2_model_ioctl_g_flash(struct file *file,struct v4l2_dump_flash *flash_dump);
int v4l2_model_ioctl_s_flash(struct file *file,struct v4l2_dump_flash *flash_update);
#else
int v4l2_model_ioctl_g_flash(struct file *file, unsigned char *flash);
int v4l2_model_ioctl_s_flash(struct file *file, unsigned char *flash);
#endif
int v4l2_model_ioctl_s_flash_rx(struct file *file,int *rx_update);

int v4l2_model_ioctl_g_dv_timings(struct file *file, void *fd,
                                struct v4l2_dv_timings *timings);
int v4l2_model_ioctl_s_dv_timings(struct file *file, void *fd,
                                struct v4l2_dv_timings *timings);

int v4l2_model_ioctl_enum_std(struct file *file, void *fd,
                                struct v4l2_standard *std);

int v4l2_model_ioctl_s_std(struct file *file, void *fd,
            v4l2_std_id std);
int v4l2_model_ioctl_g_std(struct file *file, void *fd,
            v4l2_std_id *std);
int v4l2_model_ioctl_querystd(struct file *file, void *fd,
            v4l2_std_id *std);

int v4l2_model_g_tuner(struct file *file, void *fd,
            struct v4l2_tuner *tuner);
int v4l2_model_s_tuner(struct file *file, void *fd,
            const struct v4l2_tuner *tuner);

int v4l2_model_ioctl_g_aviinfoframe(struct file *file, U8_T *aviinfo);

int v4l2_model_ioctl_g_vendorinfoframe(struct file *file, U8_T *vendorinfo);

int v4l2_model_ioctl_g_audioinfoframe(struct file *file, U8_T *audioinfo);

int v4l2_model_ioctl_s_bypassmode(struct file *file, int *bypass_disable);

int v4l2_model_ioctl_s_pixelformat(struct file *file, int *pixel_format);

int v4l2_model_ioctl_g_hdcp(struct file *file, int *hdcp_flag);

int v4l2_model_ioctl_g_ITU(struct file *file, int *ITU_flag);

int v4l2_model_ioctl_g_audiorate(struct file *file, int *audio_rate);

#if defined (AVER_CARD_CN312S)
int v4l2_model_ioctl_g_bufferinfo(struct file *file, int *buffer_info);
int v4l2_model_ioctl_s_linenum(struct file *file, int *line_num);
int v4l2_model_ioctl_g_blocknum(struct file *file, int *block_num);
int v4l2_model_ioctl_g_last_blocksize(struct file *file, int *last_blocksize);
#elif defined (AVER_CARD_CN312M)
int v4l2_model_ioctl_g_flash(struct file *file, struct v4l2_dump_flash *flash);
int v4l2_model_ioctl_s_flash(struct file *file, struct v4l2_dump_flash *flash);
#endif


#endif /* V4L2_MODEL_IOCTL_H_ */
